<?php
    require_once( "../../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    
    require_once( "core/db/tables/SLAACTable.php" );
    require_once( "core/access/sl_agent_patterns.php" );
   
    $action = array_key_exists( 'action', $_REQUEST )?$_REQUEST['action']:null;
    $service = array_key_exists( 'service', $_REQUEST )?$_REQUEST['service']:null;
    
    if ( $action == "Update" )
    {   
        require_once( "core/db/tables/SLConfigTable.php" );
        $config_table = new SLConfigTable( $db );

        $enabled = $_REQUEST['enabled'];
        $mode = $_REQUEST['mode'];

        // This is nasty....
        switch ( $service )
        {
            case _SL_AAC_BROWSE:
                $mode_opt = $config_table->getOption( "BrowseAACMode" );
                $success = $mode_opt->setValue( $mode );
                $sl_config->setBrowseAACMode( $mode_opt->getValue() );

                $enabled_opt = $config_table->getOption( "BrowseAACEnabled" );
                $success = $enabled_opt->setValue( strtolower( $enabled ) ) && $success;
                $sl_config->setBrowseAACEnabled( (strtoupper( $enabled_opt->getValue() ) == "TRUE")?true:false);

                break;
            
            case _SL_AAC_STREAM:
                $mode_opt = $config_table->getOption( "StreamAACMode" );
                $success = $mode_opt->setValue( $mode );
                $sl_config->setStreamAACMode( $mode_opt->getValue() );

                $enabled_opt = $config_table->getOption( "StreamAACEnabled" );
                $success = $enabled_opt->setValue( strtolower( $enabled ) ) && $success;
                $sl_config->setStreamAACEnabled( (strtoupper( $enabled_opt->getValue() ) == "TRUE")?true:false);

                break;
            
            case _SL_AAC_DOWNLOAD:
                $mode_opt = $config_table->getOption( "DownloadAACMode" );
                $success = $mode_opt->setValue( $mode );
                $sl_config->setDownloadAACMode( $mode_opt->getValue() );

                $enabled_opt = $config_table->getOption( "DownloadAACEnabled" );
                $success = $enabled_opt->setValue( strtolower( $enabled ) ) && $success;
                $sl_config->setDownloadAACEnabled( (strtoupper( $enabled_opt->getValue() ) == "TRUE")?true:false);

                break;

        }
    }
    
    $table = new SLAACTable( $db );
   
    $allow = $table->getEntriesByServiceAndRule( $service, _SL_AAC_ALLOW );
    $deny = $table->getEntriesByServiceAndRule(  $service, _SL_AAC_DENY );
    
    // This is nasty....
    switch ( $service )
    {
        case _SL_AAC_BROWSE:
            $service_name = "Browse";
            $enabled = $sl_config->getBrowseAACEnabled();
            $mode = $sl_config->getBrowseAACMode();
            break;
        
        case _SL_AAC_STREAM:
            $service_name = "Stream";
            $enabled = $sl_config->getStreamAACEnabled();
            $mode = $sl_config->getStreamAACMode();
            break;
        
        case _SL_AAC_DOWNLOAD:
            $service_name = "Download";
            $enabled = $sl_config->getDownloadAACEnabled();
            $mode = $sl_config->getDownloadAACMode();
            break;

    }   

    $sl_admin_nav_links = array( "Home" => "../../index.php", "Agent Access" => "agent_access.php", "$service_name Access" => "" );

    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "$service_name Agent Access Control", 
        "" );

    require( "core/theme/includes/admin_header.php" );
?>
      <form action="edit_agent_access.php" method="get">
        <input type='hidden' name='service' value='<?php echo $service; ?>' >
        <table style='border: 1px solid black;'>
          <tr>
            <td style='border-bottom: 1px solid black'><h3>General Configuation</h3></td>
          </tr>
            <td style='border-bottom: 1px solid black'>
              <table width='100%'>
                <tr>
                  <td width='1%' nowrap='nowrap' align='left'><strong>Enabled: </strong></td>
                  <td width='99%' align='left'>
                    <select name="enabled">
                      <option value="true" <?php echo ($enabled?"selected='selected'":""); ?>>Yes</option>
                      <option value="false" <?php echo (!$enabled?"selected='selected'":""); ?>>No</option>
                    </select>
                  </td>
                </tr>
                <tr>
                  <td width='1%' nowrap='nowrap' align='left'><strong>Access Mode: </strong></td>
                  <td width='99%' align='left'>
                    <select name="mode">
                      <option value="<?php echo _SL_AAC_ALLOW; ?>" <?php echo ($mode==_SL_AAC_ALLOW?"selected='selected'":""); ?>>Allow Only List</option>
                      <option value="<?php echo _SL_AAC_DENY; ?>" <?php echo ($mode==_SL_AAC_DENY?"selected='selected'":""); ?>>Deny List</option>
                    </select>
                  </td>
                </tr>
              </table>
            </td>
          </tr>
          <tr>
            <td align="right" colspan="2">
              <input type="submit" name="action" value="Update">
            </td>
          </tr>
        </table>
      </form>
      <br>
      <!-- Allow Rules -->
      <table>
        <tr>
          <td valign="top">
            <form action='edit_aac_rule.php' method='get'>
              <input type='hidden' name='service' value='<?php echo $service; ?>' >
              <input type='hidden' name='rule' value='<?php echo _SL_AAC_ALLOW; ?>' >
              <table style='border: 1px solid black;' width="100%">
                <tr>
                  <td style='border-bottom: 1px solid black'>
                    <table width='100%'>
                      <tr>
                        <td style='border-bottom: 1px solid black'><h3>Allow Only These Agents</h3></td>
                      </tr>
                      <tr>
                        <td>
                          <table bgcolor='#CCCCCC' width='100%' style='border: 1px solid black'>
                            <tr>
                              <th>Match Type</th>
                              <th>Agent Pattern</th>
                            </tr>
                            <?php
                              foreach( $allow as $entry )
                              {
                                switch ( $entry->getPatternType() )
                                {
                                    case _SL_AAC_IS:
                                        $type = "Is";
                                        $pattern = $entry->getPattern();
                                        break;

                                    case _SL_AAC_CONTAINS:
                                        $type = "Contains";
                                        $pattern = $entry->getPattern();
                                        break;

                                    case _SL_AAC_REGEX:
                                        $type = "Reg Ex";
                                        $pattern = $entry->getPattern();
                                        break;

                                    case _SL_AAC_COMMON:
                                        $type = "Common Agent";
                                        $pattern = getSLAgentName( $entry->getPattern() );
                                        break;
                                }
                            ?>
                            <tr>
                              <td style='padding-right: 20px;' bgcolor='#EEEEEE'><?php echo $type; ?></td>
                              <td style='padding-right: 20px;' bgcolor='#EEEEEE'><?php echo $pattern; ?></td>
                            </tr>
                            <?php
                              }
                            ?>
                          </table>
                        </td>
                      </tr>
                    </table>
                  </td>
                </tr>
                <tr>
                  <td align='right'>
                    <input type='submit' value='Modify'>
                  </td>
                </tr>
              </table>
            </form>
          </td>
          <!-- Deny Rule -->
          <td valign="top">
            <form action='edit_aac_rule.php' method='get'>
              <input type='hidden' name='service' value='<?php echo $service; ?>' >
              <input type='hidden' name='rule' value='<?php echo _SL_AAC_DENY; ?>' >
              <table style='border: 1px solid black;' width="100%">
                <tr>
                  <td style='border-bottom: 1px solid black'>
                    <table width='100%'>
                      <tr>
                        <td style='border-bottom: 1px solid black'><h3>Deny These Agents</h3></td>
                      </tr>
                      <tr>
                        <td style='padding-left: 10px;'>
                          <table bgcolor='#CCCCCC' width='100%' style='border: 1px solid black'>
                            <tr>
                              <th>Match Type</th>
                              <th>Agent Pattern</th>
                            </tr>
                            <?php
                              foreach( $deny as $entry )
                              {
                                switch ( $entry->getPatternType() )
                                {
                                    case _SL_AAC_IS:
                                        $type = "Is";
                                        $pattern = $entry->getPattern();
                                        break;

                                    case _SL_AAC_CONTAINS:
                                        $type = "Contains";
                                        $pattern = $entry->getPattern();
                                        break;

                                    case _SL_AAC_REGEX:
                                        $type = "Reg Ex";
                                        $pattern = $entry->getPattern();
                                        break;

                                    case _SL_AAC_COMMON:
                                        $type = "Common Agent";
                                        $pattern = getSLAgentName( $entry->getPattern() );
                                        break;
                                }
                            ?>
                            <tr>
                              <td style='padding-right: 20px;' bgcolor='#EEEEEE'><?php echo $type; ?></td>
                              <td style='padding-right: 20px;' bgcolor='#EEEEEE'><?php echo $entry->getPattern(); ?></td>
                            </tr>
                            <?php
                              }
                            ?>
                          </table>
                        </td>
                      </tr>
                    </table>
                  </td>
                </tr>
                <tr>
                  <td align='right'>
                    <input type='submit' value='Modify'>
                  </td>
                </tr>
              </table>
            </form>
          </td>
        </tr>
      </table>
      <a href="agent_access.php">Back</a>
<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
