<?php
    require_once( "../../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    
    $action = array_key_exists( 'action', $_REQUEST )?$_REQUEST['action']:null;
    $service = array_key_exists( 'service', $_REQUEST )?$_REQUEST['service']:null;
    $rule = array_key_exists( 'rule', $_REQUEST )?$_REQUEST['rule']:null;

    if ( isset( $rule ) )
    {
        $rule = strtolower( $rule );
    }

    require_once( "core/db/tables/SLHACTable.php" );

    $table = new SLHACTable( $db );

    if( isset( $action  ) )
    {
        if ( $action == "add_host" )
        {
            $host = $_REQUEST["host"];
            $ip = gethostbyname( $host );
            $table->createHACEntry( $ip, $ip, $rule, $service );
        }
        else if ( $action == "add_range" )
        {
            $start_ip = $_REQUEST["start_ip"];
            $end_ip = $_REQUEST["end_ip"];
            $table->createHACEntry( $start_ip, $end_ip, $rule, $service );
        }
        else if ( $action == "add_cidr" )
        {
            require( "core/net/SLCIDRRange.php" );
            $cidr_string = $_REQUEST["cidr_range"];
            $cidr = new SLCIDRRange( $cidr_string );
            
            $valid = $cidr->parse();

            if ( !$valid )
            {
                echo $cidr->getError();
                die();
            }
            else
            {
                $table->createHACEntry( $cidr->getLowIPString(), $cidr->getHighIPString(), $rule, $service );
            }
        }
        else if ( $action == "delete" )
        {
            $delete = $_REQUEST["delete_list"];
            $keys = array_keys( $delete );
            foreach( $keys as $key )
            {
                $table->deleteHACEntryById( $key );
            }
        }
    }
    
    $entries = $table->getEntriesByServiceAndRule( $service, $rule );
    $javascripts = array( "access.js" );
    $service_name = ucfirst( $service );
    $rule_name = ucfirst( $rule );
    $sl_admin_nav_links = array( 
        "Home" => "../../index.php", 
        "Host Access" => "host_access.php", 
        "$service_name Access" => "edit_host_access?service=$service",
        "Edit $rule_name Rules" => "" );

    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "$service_name Host Access $rule_name Rules", 
        "" );

    require( "core/theme/includes/admin_header.php" );
?>
      <script language="javascript" type="text/javascript" src="access.js" ></script>
      <table width="100%">
        <tr>
          <td valign="top">
            <form action="edit_hac_rule.php" id="rules_form">
              <input type="hidden" name="action" value="delete">
              <input type="hidden" name="service" value="<?php echo $service; ?>">
              <input type="hidden" name="rule" value="<?php echo $rule; ?>">
              <table style='border: 1px solid black;' width="100%">
                <tr>
                  <td style='border-bottom: 1px solid black' colspan="2">
                    <table width='100%'>
                      <tr>
                        <td style='border-bottom: 1px solid black'><h3>Current Rules</h3></td>
                      </tr>
                      <tr>
                        <td>
                          <table bgcolor='#CCCCCC' width='100%' style='border: 1px solid black'>
                            <tr>
                              <th></th>
                              <th>From</th>
                              <th>To</th>
                            </tr>
                            <?php
                              foreach( $entries as $entry )
                              {
                            ?>
                            <tr>
                              <td bgcolor='#EEEEEE'>
                                <input type="checkbox" name="delete_list[<?php echo $entry->getEntryId(); ?>]">
                              </td>
                              <td style='padding-right: 20px;' bgcolor='#EEEEEE'><?php echo $entry->getStartIP(); ?></td>
                              <td style='padding-right: 20px;' bgcolor='#EEEEEE'><?php echo $entry->getEndIP(); ?></td>
                            </tr>
                            <?php
                              }
                            ?>
                          </table>
                        </td>
                      </tr>
                    </table>
                  </td>
                </tr>
                <tr>
                  <td align='left'>
                    <input type='button' onClick="handleSelect( true )" value='Select All'>
                    <input type='button' onClick="handleSelect( false )" value='Deselect All'>
                  </td>
                  <td align='right'>
                    <input type='submit' value='Delete'>
                  </td>
                </tr>
              </table>
            </form>
          </td>
          <td style="padding-left: 30px" valign="top">
            <table width="100%">
              <tr>
                <td>
                  <form action="edit_hac_rule.php" method="POST">
                    <input type="hidden" name="action" value="add_host">
                    <input type="hidden" name="service" value="<?php echo $service; ?>">
                    <input type="hidden" name="rule" value="<?php echo $rule; ?>">
                    <table width="100%" style="border: 1px solid black">
                      <tr>
                        <td colspan="2">
                          Add Single Host (hostname or IP):
                        </td>
                      </tr>
                      <tr>
                        <td>
                          Host: <input type="text" name="host">
                        </td>
                        <td>
                          <input type="submit" name="add" value="Add">
                        </td>
                      </tr>
                    </table>
                  </form>
                </td>
              </tr>
              <tr>
                <td style="padding-top: 15px">
                  <form action="edit_hac_rule.php" method="POST">
                    <input type="hidden" name="action" value="add_range">
                    <input type="hidden" name="service" value="<?php echo $service; ?>">
                    <input type="hidden" name="rule" value="<?php echo $rule; ?>">
                    <table width="100%" style="border: 1px solid black">
                      <tr>
                        <td colspan="3">
                          Add IP Range: 
                        </td>
                      </tr>
                      <tr>
                        <td>
                          Start IP: <input type="text" name="start_ip">
                        </td>
                        <td>
                          End IP: <input type="text" name="end_ip">
                        </td>
                        <td>
                          <input type="submit" name="add" value="Add">
                        </td>
                      </tr>
                    </table>
                  </form>
                </td>
              </tr>
                <td style="padding-top: 15px">
                  <form action="edit_hac_rule.php" method="POST">
                    <input type="hidden" name="action" value="add_cidr">
                    <input type="hidden" name="service" value="<?php echo $service; ?>">
                    <input type="hidden" name="rule" value="<?php echo $rule; ?>">
                    <table width="100%" style="border: 1px solid black">
                      <tr>
                        <td colspan="2">
                          Add Range using CIDER Notation:
                        </td>
                      </tr>
                      <tr>
                        <td>
                          IP Range: <input type="text" name="cidr_range">
                        </td>
                        <td>
                          <input type="submit" name="add" value="Add">
                        </td>
                      </tr>
                    </table>
                  </form>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <a href="edit_host_access.php?service=<?php echo $service; ?>">Back</a>
<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
