<?php
    require_once( "../../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );

    require_once( "core/db/tables/SLUserTable.php" );
    require_once( "core/db/db_init.php" );
    
    $user_table = new SLUserTable( $db );
    $users_with_browse = $user_table->getUsersByPrivelege( "browse", 1 );
    $everyone_browse = !$sl_config->getBrowsingRequiresAuth();

    $users_with_stream = $user_table->getUsersByPrivelege( "stream", 1 );
    $everyone_stream = !$sl_config->getStreamingRequiresAuth();
    
    $users_with_download = $user_table->getUsersByPrivelege( "download", 1 );
    $everyone_download = !$sl_config->getDownloadingRequiresAuth();

    $users_with_admin= $user_table->getUsersByPrivelege( "admin", 1 );
    $everyone_admin = !$sl_config->getAdminRequiresAuth();
        
    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "Streamline User Privileges", 
        "" );

    $sl_admin_nav_links = array( "Home" => "../../index.php", "User Privileges" => "" );
    require( "core/theme/includes/admin_header.php" );
?>
          <!-- Start admin/config/access_control/user_privileges.php -->
          <table width="100%" cellpadding="0" border="0" style="" >
            <tr>
              <td>
                <p>Please choose which service you would like to edit access control for:</p>
              </td>
            </tr>
            <tr>
              <td>
                <table>
                  <tr>
                    <td align="center" valign="top" style="padding-right: 25px;">
                      <strong>Browse</strong><br>
                      <select style="height: 200px; width: 100px;" onClick="" size=2 id="availableUsers" name="availableUsers" >
                        <?php
                          if ( $everyone_browse )
                          {
                              echo "<option value='EVERYONE'>EVEYONE</option>\n";
                          }
                        
                          foreach( array_keys( $users_with_browse ) as $key )
                          {
                              $value = $users_with_browse[$key];
                              echo "<option value='$key'>".$value->getUserName()."</option>\n";
                          }
                        ?>
                      </select><br><br>
                      <button onclick="document.location='edit_user_privileges.php?service=browse'">Edit</button>
                    </td>
                    <td align="center" valign="top" style="padding-right: 25px;">
                      <strong>Stream</strong><br>
                      <select style="height: 200px; width: 100px;" onClick="" size=2 id="availableUsers" name="availableUsers" >
                        <?php
                          if ( $everyone_stream )
                          {
                              echo "<option value='EVERYONE'>EVEYONE</option>\n";
                          }
                          foreach( array_keys( $users_with_stream ) as $key )
                          {
                              $value = $users_with_stream[$key];
                              echo "<option value='$key'>".$value->getUserName()."</option>\n";
                          }
                        ?>
                      </select><br><br>
                      <button onclick="document.location='edit_user_privileges.php?service=stream'">Edit</button>
                    </td>
                    <td align="center" valign="top" style="padding-right: 25px;">
                      <strong>Download</strong><br>
                      <select style="height: 200px; width: 100px;" onClick="" size=2 id="availableUsers" name="availableUsers" >
                        <?php
                          if ( $everyone_download )
                          {
                              echo "<option value='EVERYONE'>EVEYONE</option>\n";
                          }
                          foreach( array_keys( $users_with_download ) as $key )
                          {
                              $value = $users_with_download[$key];
                              echo "<option value='$key'>".$value->getUserName()."</option>\n";
                          }
                        ?>
                      </select><br><br>
                      <button onclick="document.location='edit_user_privileges.php?service=download'">Edit</button>
                    </td>
                    <td align="center" valign="top" style="padding-right: 25px;">
                      <strong>Admin</strong><br>
                      <select style="height: 200px; width: 100px;" onClick="" size=2 id="availableUsers" name="availableUsers" >
                        <?php
                          if ( $everyone_admin )
                          {
                              echo "<option value='EVERYONE'>EVEYONE</option>\n";
                          }
                          foreach( array_keys( $users_with_admin ) as $key )
                          {
                              $value = $users_with_admin[$key];
                              echo "<option value='$key'>".$value->getUserName()."</option>\n";
                          }
                        ?>
                      </select><br><br>
                      <button onclick="document.location='edit_user_privileges.php?service=admin'">Edit</button>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
          </table>
          <br>
          <a class="admin_link" href="../../index.php">Back to Admin Home</a>
          <!-- End Admin Body -->
<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
