<?php
    require_once( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    
    $op = array_key_exists( 'operation', $_REQUEST )?$_REQUEST['operation']:null;

    if ( isset( $op ) && $op != "Ok" )
    {
        header( "Location: ../index.php" );
        echo "\n";
    }
    

    $success = false;
  
    if ( isset( $_REQUEST['locations_edited'] ) )
    {
        $wsr = stripslashes( $_REQUEST['WebServerRoot'] );
        $msr = stripslashes( $_REQUEST['MediaServerRoot'] );
        $mr = $sl_platform->normalizePath( $_REQUEST['MediaRoot'] );
    
        // Validation Here
        $valid = true; 
    
        if ( $valid )
        {
            require_once( "core/db/tables/SLConfigTable.php" );
            require_once( "core/db/db_init.php" );
            $table = new SLConfigTable( $db );
            
            $success = true;
            
            $wsr_opt = $table->getOption( "WebServerRoot" );
            $success = $wsr_opt->setValue( $wsr );
            $sl_config->setWebServerRoot( $wsr_opt->getValue() );
            
            $msr_opt = $table->getOption( "MediaServerRoot" );
            $success = $msr_opt->setValue( $msr ) && $success;
            $sl_config->setMediaServerRoot( $msr_opt->getValue() );
            
            $mr_opt = $table->getOption( "MediaRoot" );
            $success = $mr_opt->setValue( $mr ) && $success;
            $sl_config->setMediaRoot( $mr_opt->getValue() );

            if ( !$success )
            {
                $error =  "Could not store the user info because there was a database error.";
            }
        }
    }

    if ( $success )
    {
        header( "Location: ../index.php" );
        echo "\n";
    }
    else
    {
        $sl_admin_nav_links = array( "Home" => "../index.php", "Server Locations" => "" );
        
        require_once( "core/theme/SLPageInfo.php" );
        $sl_page_info = &new SLPageInfo( 
            SL_ADMIN_PAGE, 
            "Streamline Administration", 
            "Streamline Media Server Locations", 
            "" );
    
        require_once( "core/theme/includes/admin_header.php" );
?>
      <p>
        These values set up the core information that Streamline needs to know about to set up the basic server functionality. 
      </p>
      <form action="locations.php" method="POST">
        <input type="hidden" name="locations_edited" value="true" >
        <table class="dialog">
          <tr>
            <td class="dialog_label">Web Server Root:</td>
            <td><input type="text" name="WebServerRoot" size="50" value="<?php echo $sl_config->getWebServerRoot(); ?>"></td>
          </tr>
          <tr>
            <td class="dialog_label">Media Server Root:</td>
            <td><input type="text" name="MediaServerRoot" size="50" value="<?php echo $sl_config->getMediaServerRoot(); ?>"></td>
          </tr>
          <tr>
            <td class="dialog_label">Media Root:</td>
            <td><input type="text" name="MediaRoot" size="50" value="<?php echo $sl_config->getMediaRoot(); ?>"></td>
          </tr>
          <tr><td colspan="2" class="dialog_divider" style="height: 10px"></td></tr>
          <tr><td colspan="2" style="height: 10px"></td></tr>  
          <tr>
            <td align="right" colspan="2">
              <input type="Submit" name="operation" value="Cancel">
              <input type="Submit" name="operation" value="Ok">
            </td>
          </tr>
        </table>
      </form>
<?php
        require_once( "core/theme/includes/admin_footer.php" );
    }
?>
