<?php
    require_once( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    
    $op = array_key_exists( 'operation', $_REQUEST )?$_REQUEST['operation']:null;

    if ( isset( $op ) && $op != "Ok" )
    {
        header( "Location: ../index.php" );
        echo "\n";
    }
    
    $success = false;
  
    if ( isset( $_REQUEST['logs_edited'] ) )
    {
        $browse = $_REQUEST['LogBrowsing'];
        $stream = $_REQUEST['LogStreaming'];
        $download = $_REQUEST['LogDownloading'];
    
        // Validation Here
        $valid = true; 
    
        if ( $valid )
        {
            require_once( "core/db/tables/SLConfigTable.php" );
            require_once( "core/db/db_init.php" );
            $table = new SLConfigTable( $db );
            
            $success = true;
            
            $lb_opt = $table->getOption( "LogBrowsing" );
            $success = $lb_opt->setValue( $browse );
            $sl_config->setLogBrowsing( (strtoupper( $lb_opt->getValue() ) == "YES")?true:false  );
            
            $ls_opt = $table->getOption( "LogStreaming" );
            $success = $ls_opt->setValue( $stream ) && $success;
            $sl_config->setLogStreaming( (strtoupper( $ls_opt->getValue() ) == "YES")?true:false  );
            
            $ld_opt = $table->getOption( "LogDownloading" );
            $success = $ld_opt->setValue( $download ) && $success;
            $sl_config->setLogDownloading( (strtoupper( $ld_opt->getValue() ) == "YES")?true:false  );
            
            $_SESSION[SL_LOGGER] =& new SLLogger( $sl_config );
            
            if ( !$success )
            {
                $error =  "Could not store the user info because there was a database error.";
            }
        }
    }

    if ( $success )
    {
        header( "Location: ../index.php" );
        echo "\n";
    }
    else
    {
        $sl_admin_nav_links = array( "Home" => "../index.php", "Logging Options" => "" );
        
        require_once( "core/theme/SLPageInfo.php" );
        $sl_page_info = &new SLPageInfo( 
            SL_ADMIN_PAGE, 
            "Streamline Administration", 
            "Streamline Logging Options", 
            "" );
    
        require_once( "core/theme/includes/admin_header.php" );
?>
      <p>
        These values set up the logging scheme for the server.
      </p>
      <form action="logs.php" method="POST">
        <input type="hidden" name="logs_edited" value="true" >
        <table class="dialog">
          <tr>
            <td class="dialog_label">Log Browsing:</td>
            <td>
              <input type="radio" name="LogBrowsing" value="yes" <?php echo  $sl_config->getLogBrowsing()?" checked=\"checked\"":""; ?>>Yes
              <input type="radio" name="LogBrowsing" value="no" <?php echo  !$sl_config->getLogBrowsing()?" checked=\"checked\"":""; ?>> No 
            </td>
          </tr>
          <tr>
            <td class="dialog_label">Log Streaming:</td>
            <td>
              <input type="radio" name="LogStreaming" value="yes" <?php echo  $sl_config->getLogStreaming()?" checked=\"checked\"":""; ?>>Yes
              <input type="radio" name="LogStreaming" value="no" <?php echo  !$sl_config->getLogStreaming()?" checked=\"checked\"":""; ?>> No 
            </td>
          </tr>
          <tr>
            <td class="dialog_label">Log Downloading:</td>
            <td>
              <input type="radio" name="LogDownloading" value="yes" <?php echo  $sl_config->getLogDownloading()?" checked=\"checked\"":""; ?>>Yes
              <input type="radio" name="LogDownloading" value="no" <?php echo  !$sl_config->getLogDownloading()?" checked=\"checked\"":""; ?>> No 
            </td>
          </tr>
          <tr><td colspan="2" class="dialog_divider" style="height: 10px"></td></tr>
          <tr><td colspan="2" style="height: 10px"></td></tr>  
          <tr>
            <td align="right" colspan="2">
              <input type="Submit" name="operation" value="Cancel">
              <input type="Submit" name="operation" value="Ok">
            </td>
          </tr>
        </table>
      </form>
<?php
        require_once( "core/theme/includes/admin_footer.php" );
    }
?>
