<?php
    require_once( "../../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    
    $op = array_key_exists( 'edit_op', $_REQUEST )?$_REQUEST['edit_op']:null;

    if ( isset( $op ) && $op != "Ok" )
    {
        header( "Location: ../../index.php" );
        echo "\n";
        die();
    }
    
    $success = false;
    
    if ( array_key_exists( 'order_edited', $_REQUEST ) )
    {
        $sort_order = $_REQUEST['sort_order'];
        $so = implode( ",", $sort_order );
        
        // Validation Here
        $valid = true; 
    
        if ( $valid )
        {
            require_once( "core/db/tables/SLConfigTable.php" );
            require_once( "core/db/db_init.php" );
            $table = new SLConfigTable( $db );
            
            $so_opt = $table->getOption( SL_SORT_ORDER );
            $success = $so_opt->setValue( $so );
            $sl_config->setSortOrder( $so_opt->getValue() );
        }
    }
    
    if ( $success )
    {
        header( "Location: ../../index.php" );
        echo "\n";
        die();
    }
    else
    {
        $selected_in = $sl_config->getSortOrder();
        $total = array( 
            "TITLE" => "Title", 
            "ARTIST" => "Artists", 
            "ALBUM" => "Album", 
            "TRACK" => "Track", 
            "GENRE" => "Genre"
        );

        $available = array();
        $selected = array();

        foreach( $selected_in as $sel )
        {
            $selected[$sel] = $total[$sel];
        }
        
        foreach( array_keys( $total ) as $key )
        {
            if ( !array_key_exists( $key, $selected_in ) )
            {
                $available[$key] = $total[$key];
            }   
        }

        $sl_admin_nav_links = array( "Home" => "../../index.php", "Media Sort Order" => "" );
        
        require_once( "core/theme/SLPageInfo.php" );
        $sl_page_info = &new SLPageInfo( 
            SL_ADMIN_PAGE, 
            "Streamline Administration", 
            "Media Sort Order", 
            "createListObjects()" );
        
        require( "core/theme/includes/admin_header.php" );
?>
      <script language="javascript" type="text/javascript" src="option.js" ></script>
      <p>
       This option determines the order in which media files are sorted in the browser. 
      </p>
    <form id="sort_order" action="sort_order.php" method="get" onSubmit="preProcessSubmit( this )">
      <input type="hidden" name="order_edited" value="true">
      <table border="0" width="400" class="dialog">
        <tr>
           <td class="dialog_label" align="center">Available Attributes</td>
           <td></td>
           <td class="dialog_label" align="center">Selected Attributes</td>
           <td></td>
        </tr>
        <tr>
          <td>
            <select style="height: 200px; width: 200px;" onClick="deselectSelectedList()" size=2 id="availableOptions" name="availableOptions" onChange="updateButtonState()">
              <?php
                foreach( array_keys( $available ) as $key )
                {
                    $value = $available[$key];
                    echo "<option value='$key'>$value</option>\n";
                }
              ?>
            </select>
          </td>
          <td valign="middle" align="center" >
            <input type="button" onclick="addAttribute()" id="add_button" value="Add"> 
            <br>
            <input type="button" onclick="delAttribute()" id="remove_button" value="Remove"> 
          </td>
          <td>
            <select size="4" onClick="deselectAvailableList()" style="height: 200px; width: 200px;" id="selectedOptions" name="selectedOptions" onChange="updateButtonState()">
              <?php
                foreach( array_keys( $selected ) as $key )
                {
                    $value = $selected[$key];
                    echo "<option value='$key'>$value</option>\n";
                }
              ?>
            </select>
          </td>
          <td valign="middle" align="center">
            <input type="button" onclick="moveUp()" id="up_button" value="Up"><br>
            <input type="button" onclick="moveDown()" id="down_button" value="Down">
          </td>
        </tr>
        <tr><td colspan="4" class="dialog_divider" style="height: 10px"></td></tr>
        <tr><td colspan="4" style="height: 10px"></td></tr>  
        <tr>
          <td colspan="4" align="right">
            <input type="submit" name="edit_op" value="Cancel">
            <input type="submit" name="edit_op" value="Ok">
          </td>
          <td>
          </td>
        </tr>
      </table>
    </form>
<?php
        require_once( "core/theme/includes/admin_footer.php" );
    }
?>
