<?php
    require( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    
    $sl_admin_nav_links = array( "Home" => "../index.php", "Streamline Maintenance" => "" );
    
    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "Streamline Maintenance", 
        "" );
    
    require( "core/theme/includes/admin_header.php" );
?>
          <!-- Start Admin Body -->
          <table width="100%" cellpadding="0" border="0" style="" >
            <tr>
              <td>
                <p>
                 Generally speaking, Streamline is designed with database integrity in mind. 
                 However, certain database engines support differing features in the areas of 
                 transactions and constraints. Therefore, if a PHP script exits abnormally (if 
                 the connection is lost) it is possible that data may be left in a strange 
                 state. Additionally, bugs can leave orphaned data in the database that you won't 
                 see but takes up space. Lastly, log files and other entries generally grow larger 
                 over time.
               </p>
               <p>
                 This page is meant to help you keep a handle on your streamline database by 
                 allowing you to perform several maintenance actives on your database to improve 
                 it efficiency and integrity.
                </p>
                <p><strong>Choose Maintenance Activities:</strong></p>
                <form action="do_clean_db.php">
                  <table>
                    <tr>
                      <td><input type="checkbox" name="truncate_logs"></td>
                      <td>Remove log entries older than: </td>
                      <td>
                        <select name="log_time_period">
                          <option value="day">1 Day</option>
                          <option value="week">7 Days</option>
                          <option value="month">30 Days</option>
                        </select>
                      </td>
                    </tr>
                    <tr>
                      <td><input type="checkbox" name="truncate_stats"></td>
                      <td>Remove statistics older than: </td>
                      <td>
                        <select name="stats_time_period">
                          <option value="day">1 Day</option>
                          <option value="week">7 Days</option>
                          <option value="month">30 Days</option>
                        </select>
                      </td>
                    </tr>
                    <tr>
                      <td><input type="checkbox" name="non_user_artifacts"></td>
                      <td colspan="2">Remove artifcts for users that no longer exists.</td>
                    </tr>
                  </table>
                  <br>
                  <input type="submit" value="Clean Database">
                </form>
              </td>
            </tr>
          </table>
          <!-- End Admin Body -->
<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
