<?php
    require_once( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );

    require_once( "core/db/db_init.php" );
    require_once( "core/stats/SLDailyStatsEngine.php" );
    require_once( "core/stats/SLMediaStatsEngine.php" );
    require_once( "core/stats/SLUserStatsEngine.php" );
    require_once( "core/db/tables/SLUserTable.php" );
    require_once( "core/media_info/MediaInfoCache.php" );

    require_once( "core/ui/tables/SLTable.php" );
    require_once( "core/ui/tables/SLSimpleTableModel.php" );
    
    
    // MEDIA STATISTICS 
    $media_stats_engine = &new SLMediaStatsEngine( $db );
    
    // MEDIA BY STREAMS
    $media_by_streams = &$media_stats_engine->getTopMediaRankedByStreams( 10 );
    
    $columns = array( "Rank", "Path", "#" );
    $data = array();
    
    $rank = 1;
    $paths = array_keys( $media_by_streams );
    foreach( $paths as $path )
    {
        $streams = $media_by_streams[$path];
        $data[] = array( $rank, $path, $streams );
        $rank++;
    }

    for ( $rank; $rank <= 10; $rank++ )
    {
        $data[] = array( $rank, "", "" );
    }
    
    $mbs_table_model = &new SLSimpleTableModel( $columns, $data );
    $sl_mbs_table = &new SLTable( $mbs_table_model );
    
    
    // MEDIA BY DOWNLOADS
    $media_by_downloads = $media_stats_engine->getTopMediaRankedByDownloads( 10 );
    $columns = array( "Rank", "Path", "#" );
    $data = array();
    
    $rank = 1;
    $paths = array_keys( $media_by_downloads );
    foreach( $paths as $path )
    {
        $dls = $media_by_downloads[$path];
        $data[] = array( $rank, $path, $dls );
        $rank++;
    }

    for ( $rank; $rank <= 10; $rank++ )
    {
        $data[] = array( $rank, "", "" );
    }
    
    $mbd_table_model = &new SLSimpleTableModel( $columns, $data );
    $sl_mbd_table = &new SLTable( $mbd_table_model );
    
    // USER STATISTICS
    $user_stats_engine = &new SLUserStatsEngine( $db );
    $user_table = new SLUserTable( $db );
    
    // USERS BY STREAMS
    $uids_by_streams = $user_stats_engine->getTopUsersRankedByStreams( 5 );
    $keys = array_keys( $uids_by_streams );
    
    $columns = array( "Rank", "User Name", "#" );
    $data = array();
    
    $rank = 1;
    foreach( $keys as $key )
    {
        $user = $user_table->getUserById( $key );
        $data[] = array( $rank, $user->getUserName(), $uids_by_streams[$key] );
        $rank++;
    }

    for ( $rank; $rank <= 5; $rank++ )
    {
        $data[] = array( $rank, "", "" );
    }
    
    $ubs_table_model = &new SLSimpleTableModel( $columns, $data );
    $ubs_table = &new SLTable( $ubs_table_model );
   
    // USERS BY DOWNLOADS 
    $uids_by_downloads = $user_stats_engine->getTopUsersRankedByDownloads( 5 );
    $keys = array_keys( $uids_by_downloads );

    $columns = array( "Rank", "User Name", "#" );
    $data = array();
    
    $rank = 1;
    foreach( $keys as $key )
    {
        $user = $user_table->getUserById( $key );
        $data[] = array( $rank, $user->getUserName(), $uids_by_downloads[$key] );
        $rank++;
    }

    for ( $rank; $rank <= 5; $rank++ )
    {
        $data[] = array( $rank, "", "" );
    }
    
    $ubd_table_model = &new SLSimpleTableModel( $columns, $data );
    $ubd_table = &new SLTable( $ubd_table_model );
   
    foreach( $keys as $key )
    {
        $user = $user_table->getUserById( $key );
        $users_by_downloads[$user->getUserName()] = $uids_by_downloads[$key];
    }
    
    $sl_admin_nav_links = array( "Home" => "../index.php", "Server Statistics" => "" );

    require_once( "core/theme/SLPageInfo.php" );
    $sl_page_info = &new SLPageInfo( 
        SL_ADMIN_PAGE, 
        "Streamline Administration", 
        "Server Statistics", 
        "" );

    require_once( "core/theme/includes/admin_header.php" );
?>
          <!-- Start Admin Body -->
          <h3>Service Usage Statistics</h3>
          <table>
            <tr>
              <td style="padding-right: 15px">
                 <a href="advanced_service_graph.php?service=browse"><img class="stats_graph" border=0 src="service_stats_graph.php?service=browse&amp;width=250&amp;height=125"></a>
              </td>
              <td style="padding-right: 15px">
                <a href="advanced_service_graph.php?service=stream"><img class="stats_graph" border=0 src="service_stats_graph.php?service=stream&amp;width=250&amp;height=125"></a>
              </td>
              <td>
                <a href="advanced_service_graph.php?service=download"><img class="stats_graph" border=0 src="service_stats_graph.php?service=download&amp;width=250&amp;height=125"></a>
              </td>
            </tr>
            <tr>
              <td align="center" style="font-size: 80%">
                <a class="admin_link" href="advanced_service_graph.php?service=browse">Click For More Options</a>
              </td>
              <td align="center" style="font-size: 80%">
                <a class="admin_link" href="advanced_service_graph.php?service=stream">Click For More Options</a>
              </td>
              <td align="center" style="font-size: 80%">
                <a class="admin_link" href="advanced_service_graph.php?service=download">Click For More Options</a>
              </td>
            </tr>
          </table>
          <!-- MEDIA STATISTICS -->
          <h3 style="padding-top: 10px">Media Statistics</h3>
          <table>
            <tr>
              <td style="padding-right: 10px">
                <strong>Top Media By # of Streams:</strong>
                <div style="padding: 20px">
                <table>
                  <tr>
                    <td>
                      <?php $sl_mbs_table->generateTable(); ?>
                    </td>
                  </tr>
                  <tr>
                    <td align="right"><a class="admin_link" href="media_stats.php?stat=streams">more &gt;&gt;</a></td>
                  </tr>
                </table>
                </div>
              </td>
            </tr>
            <tr>
              <td>
                <strong>Top Meida By # of Downloads:</strong>
                <div style="padding: 20px">
                <table>
                  <tr>
                    <td>
                      <?php $sl_mbd_table->generateTable(); ?>
                    </td>
                  </tr>
                  <tr>
                    <td align="right"><a class="admin_link" href="media_stats.php?stat=downloads">more &gt;&gt;</a></td>
                  </tr>
                </table>
                </div>

              </td>
            </tr>
          </table>
          <!-- USER STATISTICS -->
          <h3 style="padding-top: 10px">User Statistics</h3>
          <table>
            <tr>
              <td style="padding-right: 10px">
                <strong>Top Users By # of Streams:</strong>
                <div style="padding: 20px">
                <table>
                  <tr>
                    <td>
                      <?php $ubs_table->generateTable(); ?>
                    </td>
                  </tr>
                  <tr>
                    <td align="right"><a class="admin_link" href="user_stats.php?stat=streams">more &gt;&gt;</a></td>
                  </tr>
                </table>
                </div>
              </td>
              <td>
                <strong>Top Users By # of Downloads:</strong>
                <div style="padding: 20px">
                <table>
                  <tr>
                    <td>
                      <?php $ubd_table->generateTable(); ?>
                    </td>
                  </tr>
                  <tr>
                    <td align="right"><a class="admin_link" href="user_stats.php?stat=downloads">more &gt;&gt;</a></td>
                  </tr>
                </table>
                </div>

              </td>
            </tr>
          </table>
          <br><br>
          <a class="admin_link" href="../index.php">Back to Admin Home</a>
          <!-- End Admin Body -->
<?php
    require_once( "core/theme/includes/admin_footer.php" );
?>
