<?php
	require_once( "../../sl_root.php" );
	require_once( "core/streamline_init.php" );
	require_once( "core/db/db_init.php" );
    require_once( "core/stats/SLDailyStatsEngine.php" );
    
    $service = isset( $_REQUEST['service'] )?$_REQUEST['service']:"stream";
    $height = isset( $_REQUEST['height'] )?$_REQUEST['height']:350;
    $width = isset( $_REQUEST['width'] )?$_REQUEST['width']:700;
    $type = isset( $_REQUEST['type'] )?$_REQUEST['type']:"week";

    $end_date = strtotime( date( "d F Y" ) ); 
    $start_date = $end_date; 
    $day_offset = 60*60*24; 
   
    $type_label ="";
    switch( $type )
    {
        case "week":
            $start_date = $end_date - ($day_offset*6);
            $type_label = "Daily";   
            break;

        case "month":
            $start_date = $end_date - ($day_offset*30);
            $type_label = "Daily";   
            break;

        case "year":
            $start_date = mktime(0, 0, 0, date("m", $end_date)-11, date("d", $end_date),  date("Y", $end_date));
            $type_label = "Monthly";   
            break;
    }
    
    $daily_stats_engine = &new SLDailyStatsEngine( $db );
    
    $stats = null;
    $service_title = "";

    switch( $service )
    {
        case "stream":
            $stats = $daily_stats_engine->getStreamsForRangeOfTime( $start_date, $end_date );
            $service_title = "Streams";
            break;
        
        case "browse":
            $stats = $daily_stats_engine->getBrowsesForRangeOfTime( $start_date, $end_date );
            $service_title = "Browses";
            break;
        
        case "download":
            $stats = $daily_stats_engine->getDownloadsForRangeOfTime( $start_date, $end_date );
            $service_title = "Downloads";
            break;
    }
    $x_axis = array();
    $series = array();

    if ( $type == "month" )
    {
        $keys = array_keys( $stats );
        $count = count( $keys );
        $mod_offest = 2 - ( ($count - 1) % 2);
        
        for( $i = $count - 1; $i >= 0 ; $i-- )
        {
            $mod = ( ($i % 2) + $mod_offest ) % 2;
            
            if ( $mod != 0 )
            {
               $cur = $stats[$keys[$i]];
               $base =  $stats[$keys[$i + $mod]];

               $stats[$keys[$i + $mod]] = $base + $cur;
               unset( $stats[$keys[$i]] );
            }
        }

        $keys = array_keys( $stats );
        foreach( $keys as $key )
        {
            $x_axis[] = date( "m-d", $key );
            $series[] = $stats[$key];
        }
    }
    else if ( $type == "year" )
    {
        $monthly = array();
        $keys = array_keys( $stats );
        
        foreach( $keys as $key )
        {
            $month = strtotime( date( "01 F Y", $key ) );
            $base =  isset( $monthly[$month] )?$monthly[$month]:0;
            $cur = $stats[$key];

            $monthly[$month] = $cur + $base;
        }

        $stats = $monthly;

        $keys = array_keys( $stats );
        foreach( $keys as $key )
        {
            $x_axis[] = date( "m-y", $key );
            $series[] = $stats[$key];
        }
    }
    else
    {
        $keys = array_keys( $stats );
        foreach( $keys as $key )
        {
            $x_axis[] = date( "m-d", $key );
            $series[] = $stats[$key];
        }
    }
?>
