<?
require_once( "core/ui/tables/SLTableModel.php" );

if ( !defined( "_SL_MEDIA_START_TABLE_MODEL" ) ){
      define( "_SL_MEDIA_START_TABLE_MODEL", 1 );

    class SLMediaStatsTableModel extends SLTableModel
    {
        var $data;
        var $columns;
        var $media_table;
        var $window;
        var $window_size;
        var $window_start;
        var $stat;

        function SLMediaStatsTableModel( &$media_table, $stat )
        {
            $this->media_table = &$media_table;
            $this->columns = array( "Rank", "Path" );
            $this->stat = $stat;

            if ( $stat == "streams" )
            {
                $this->columns[] = "Streams";
            }
            else if ( $stat == "downloads" )
            {
                $this->columns[] = "Downloads";
            }
                
        }

        function getTotalRows()
        {
            return $this->media_table->getNumberOfRankedMedia( $this->stat );
        }

        function getNumRows()
        {
            return min( $this->window_size, count( $this->window ) );
        }

        function getNumColumns()
        {
            return count( $this->columns );
        }

        function getColumnName( $index )
        {
            return $this->columns[$index];
        }
        
        function getValue( $row, $column )
        {
            $value = null;
            
            switch( $column )
            {
                case 0:
                    $value = $row + $this->window_start + 1;
                    break;

                case 1:
                    $stat = $this->window[$row];
                    $value = $stat->getPath();
                    break;

                case 2:
                    $stat = $this->window[$row];
                    if ( $this->columns[2] == "Streams" )
                    {
                        $value = $stat->getStreams();
                    }
                    else if ( $this->columns[2] == "Downloads" )
                    {
                        $value = $stat->getDownloads();
                    }
                    break;
            }
            
            return $value;
        }

        function setWindow( $size, $start )
        {
            $this->window_size = $size;
            $this->window_start = $start;

            $this->window = $this->media_table->getHighestRankedMedia( $this->stat, $size, $start );
        }

        function getWindowStart()
        {
            return $this->window_start;
        }

        function getWindowSize()
        {
            return $this->window_size;
        }

        function hasNextPage()
        {
            return $this->window_start + $this->window_size < $this->media_table->getNumberOfRankedMedia( $this->stat );
        }

        function hasPreviousPage()
        {
            return $this->window_start > 0;
        }
    }
}
?>
