<?
require_once( "core/ui/tables/SLTableModel.php" );
require_once( "core/db/tables/SLUserTable.php" );

if ( !defined( "_SL_USER_START_TABLE_MODEL" ) ){
      define( "_SL_USER_START_TABLE_MODEL", 1 );

    class SLUserStatsTableModel extends SLTableModel
    {
        var $data;
        var $columns;
        var $user_table;
        var $window;
        var $window_size;
        var $window_start;
        var $stat;
        var $user_stats_table;
        

        function SLUserStatsTableModel( &$user_stats_table, $stat )
        {
            $this->user_stats_table = &$user_stats_table;
            $this->user_table = new SLUserTable( $user_stats_table->db );
            $this->columns = array( "Rank", "User Name" );
            $this->stat = $stat;

            if ( $stat == "streams" )
            {
                $this->columns[] = "Streams";
            }
            else if ( $stat == "downloads" )
            {
                $this->columns[] = "Downloads";
            }
                
        }

        function getTotalRows()
        {
            return $this->user_stats_table->getNumberOfRankedUsers( $this->stat );
        }

        function getNumRows()
        {
            return min( $this->window_size, count( $this->window ) );
        }

        function getNumColumns()
        {
            return count( $this->columns );
        }

        function getColumnName( $index )
        {
            return $this->columns[$index];
        }
        
        function getValue( $row, $column )
        {
            $value = null;
            
            switch( $column )
            {
                case 0:
                    $value = $row + $this->window_start + 1;
                    break;

                case 1:
                    $stat = $this->window[$row];
                    $id = $stat->getUserId();
                    $user = $this->user_table->getUserById( $id );
                    $value = $user->getUserName();
                    break;

                case 2:
                    $stat = $this->window[$row];
                    if ( $this->stat == "streams" )
                    {
                        $value = $stat->getStreams();
                    }
                    else if ( $this->stat == "downloads" )
                    {
                        $value = $stat->getDownloads();
                    }
                    break;
            }
            
            return $value;
        }

        function setWindow( $size, $start )
        {
            $this->window_size = $size;
            $this->window_start = $start;

            $this->window = $this->user_stats_table->getHighestRankedUsers( $this->stat, $size, $start );
        }

        function getWindowStart()
        {
            return $this->window_start;
        }

        function getWindowSize()
        {
            return $this->window_size;
        }

        function hasNextPage()
        {
            return $this->window_start + $this->window_size < $this->user_stats_table->getNumberOfRankedUsers( $this->stat );
        }

        function hasPreviousPage()
        {
            return $this->window_start > 0;
        }
    }
}
?>
