<?php
    require_once( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "admin/auth.php" );
    
    $op = array_key_exists( 'user_add_op', $_REQUEST)?$_REQUEST['user_add_op']:null;

    if ( isset( $op ) && $op != "Ok" )
    {
        require_once( "index.php" );
        die();
    }
    
    $success = false;
    
    $passwd = "";
    $cpasswd = "";
    $uname = "";
    $fname = "";
    $lname = "";
    $email = "";
    $admin = "";
 
    if ( array_key_exists( 'new_user_entered', $_REQUEST ) )
    {
        $passwd = array_key_exists( 'passwd', $_REQUEST )?$_REQUEST['passwd']:"";
        $cpasswd = array_key_exists( 'cpasswd', $_REQUEST )?$_REQUEST['cpasswd']:"";
        $uname = array_key_exists( 'uname', $_REQUEST )?$_REQUEST['uname']:"";
        $fname = array_key_exists( 'fname', $_REQUEST )?$_REQUEST['fname']:"";
        $lname = array_key_exists( 'lname', $_REQUEST )?$_REQUEST['lname']:"";
        $email = array_key_exists( 'email', $_REQUEST )?$_REQUEST['email']:"";
        $admin = array_key_exists( 'admin', $_REQUEST )?strtolower($_REQUEST['admin']) == "on":false;
        $browse = array_key_exists( 'browse', $_REQUEST )?strtolower($_REQUEST['browse']) == "on":false;
        $stream = array_key_exists( 'stream', $_REQUEST )?strtolower($_REQUEST['stream']) == "on":false;
        $download = array_key_exists( 'download', $_REQUEST )?strtolower($_REQUEST['download']) == "on":false;

        // Validation Here
        $valid = true; 
        require_once( "core/db/tables/SLUserTable.php" );
        require_once( "core/db/db_init.php" );
  
        $table = new SLUserTable( $db );
        
        $errors = array();

        if ( strlen( $uname ) <= 0  )
        {
            $valid = false;
            array_push( $errors, "You must enter a User Name." );
        }
        else if ( $table->userExists( $uname ) )
        {
            $valid = false;
            array_push( $errors, "The selected username already existst in the system." );
        }
        
        if ( strlen( $fname ) <= 0  )
        {
            $valid = false;
            array_push( $errors, "You must enter a First Name." );
        }
   
        if ( strlen( $lname ) <= 0  )
        {
            $valid = false;
            array_push( $errors, "You must enter a Last Name." );
        }
   
        if ( $passwd != $cpasswd )
        {
            $valid = false;
            array_push( $errors, "New Password and Confrim Password do not match." );
        }
        
        if ( strlen( $passwd ) < 6 )
        {
            $valid = false;
            array_push( $errors, "Password must be at least six charachters long." );
        }
   
        if ( $valid )
        {
            $rand64= "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
            $random=rand();
            $salt=substr($rand64,$random  %  64,1).substr($rand64,($random/64) % 64,1);
            $enc_pw = crypt( $passwd, $salt );

            $success = $table->createUser( $uname, $fname, $lname, $enc_pw, $email, $admin, $browse, $stream, $download );
            
            if ( !$success )
            {
                array_push( $errors, "Could not store the user info because there was a database error." );
            }
        }
    }

    if ( $success )
    {
        header( "Location: index.php" );
        echo "\n";
        die();
    }
    else
    {
        require_once( "core/theme/SLPageInfo.php" );
        $sl_page_info = &new SLPageInfo( 
            SL_ADMIN_PAGE, 
            "Streamline Administration", 
            "Add New User", 
            "" );
    
        require( "core/theme/includes/admin_header.php" );
?>
          <!-- Start Admin Body -->
          <?php
            if ( isset( $errors ) && count( $errors ) > 0 )
            {
                echo "<p>The following errors were detected:\n";
                echo "<ul>\n";
                foreach( $errors as $error )
                {
                    echo "<li>$error</li>";
                }
                echo "</ul>\n";
                echo "</p>\n";
            }
          ?>
          <form action="add_user.php" method="post">
            <input type="hidden" name="new_user_entered" value="true">
            <table bgcolor="#CCCCCC" style="border: solid 1px black">
              <tr>
                <td><strong>User Name: </strong></td><td><input size="30" type="text" name="uname" value="<?php echo $uname; ?>"></td>
              </tr>
              <tr>
                <td><strong>First Name: </strong></td><td><input size="30" type="text" name="fname" value="<?php echo $fname; ?>"></td>
              </tr>
              <tr>
                <td><strong>Last Name: </strong></td><td><input size="30" type="text" name="lname" value="<?php echo $lname; ?>"></td>
              </tr>
              <tr>
                <td><strong>Email: </strong></td><td><input size="30" type="text" name="email" value="<?php echo $email; ?>"></td>
              </tr>
              <tr>
                <td colspan="2"><hr></td>
              </tr>
              <tr>
                <td><strong>New Password: </strong></td><td><input size="30" type="password" name="passwd"></td>
              </tr>
              <tr>
                <td><strong>Confirm Password: </strong></td><td><input size="30" type="password" name="cpasswd"></td>
              </tr>
              <tr>
                <td colspan="2"><hr></td>
              </tr>
              <tr>
                <td><strong>Privileges: </strong></td>
                <td>
                  <table width="100%">
                    <tr>
                      <td width="1%">Administrator: </td>
                      <td align="left" style="padding-left: 20px"> <input type="checkbox" name="admin"></td>
                    </tr>
                    <tr>
                      <td width="1%">Browse: </td>
                      <td align="left" style="padding-left: 20px"> <input type="checkbox" name="browse"></td>
                    </tr>
                    <tr>
                      <td width="1%">Stream: </td>
                      <td align="left" style="padding-left: 20px"> <input type="checkbox" name="stream"></td>
                    </tr>
                    <tr>
                      <td width="1%">Download: </td>
                      <td align="left" style="padding-left: 20px"> <input type="checkbox" name="download"></td>
                    </tr>
                  </table>
                </td>
              </tr>
              <tr>
                <td align="right" colspan="2" style="border-top: solid 1px black; padding-top: 5px">
                  <input type="Submit" name="user_add_op" value="Cancel">
                  <input type="Submit" name="user_add_op" value="Ok">
                </td>
              </tr>
            </table>
          </form>
          <!-- End Admin Body -->
<?php
        require_once( "core/theme/includes/admin_footer.php" );
    }
?>
