<?
require_once( "core/streamline_functions.php" );

if ( !defined( "_MEDIA_STREAMER" ) ){
      define( "_MEDIA_STREAMER", 1 );
      
    class MediaStreamer
    {
        var $path;
        var $range;
        var $title;

        function MediaStreamer( $path, $range, $title, $mime )
        {
            $this->path = $path;
            $this->range = $range;
            $this->title = $title;
            $this->mime = $mime;
        }

        
        function sendHeaders()
        {
            if ( isset( $this->range ) && $this->range != 0 )
            {
                // If the range is set then we need to send a 206 response.
                // for partial content.
                header('HTTP/1.1 206\r\n');
                
                // A response of 206 requires us to sent a Content Range header
                // to tell the client what bytes they are getting.  We will
                // also set the content lenght to the remaining part of the
                // file that needs to be sent.
                $range = $this->range;
                $size = filesize( $this->path ); 
                $length = $size - $this->range;
                $bytes = "$range-$size/".(filesize( $this->path ) + 1 );
                
                header("Content-Length: ".$length );
                header("Content-Range: bytes $bytes" );
            }
            else
            {
                // Since we use the .htaccess to direct all errors to this page,
                // we should reset the response to return code 200 in case it was
                // set to 404 for a file that doesn't exist.
                header('HTTP/1.1 200\r\n');

                // Set the length of the file.
                header("Content-Length: ".filesize( $this->path ) );
            }
            
            // This will "Suggest" to the client to display the title instead of
            // the url.  Also we tell browsers that this should be treated as an
            // attachment.
            header("Content-Disposition: attachment; filename=\"".$this->title."\"" );
            
            // Set the correct mime type.
            $mime = $this->mime;
            header("Content-type: $mime");

            // Push out the headers by echoing a newline.
        }


        function streamMedia()
        {
            $result = true;
            
            $media = fopen( $this->path, "r" );

            fseek( $media, $this->range );

            $data = fread( $media, 8192 );

            $result = strlen( $data ) > 0;

            while( strlen( $data ) > 0 )
            {
                set_time_limit( 30 );
                echo $data;
                $data = fread( $media, 8192 );
            }

            return $result;
        }
    }
}
?>
