<?
if ( !defined( "_SL_CONFIGURATION" ) ){
      define( "_SL_CONFIGURATION", 1 );

    // Locations
    define( "SL_WEB_SERVER_ROOT", "WebServerRoot" );
    define( "SL_MEDIA_SERVER_ROOT", "MediaServerRoot" );
    define( "SL_MEDIA_ROOT", "MediaRoot" );
    
    // Service Access 
    define( "SL_BROWSING_REQUIRES_AUTH", "BrowsingRequiresAuth" );
    define( "SL_STREAMING_REQUIRES_AUTH", "StreamingRequiresAuth" );
    define( "SL_DOWNLOADING_REQUIRES_AUTH", "DownloadingRequiresAuth" );
    define( "SL_ADMIN_REQUIRES_AUTH", "AdminRequiresAuth" );
    
    // Presentation
    define( "SL_SERVER_TITLE", "ServerTitle" );
    define( "SL_THEME", "Theme" );
    define( "SL_STREAM_FORMAT", "StreamFormat" );
    define( "SL_BROWSER_COLUMNS", "BrowserColumns" );
    define( "SL_SORT_ORDER", "SortOrder" );
    define( "SL_MASK_URLS", "MaskURLs" );
   
    // Host Access Control Options
    define( "SL_BROWSE_HAC_ENABLED", "BrowseHACEnabled" );
    define( "SL_STREAM_HAC_ENABLED", "StreamHACEnabled" );
    define( "SL_DOWNLOAD_HAC_ENABLED", "DownloadHACEnabled" );
    define( "SL_GLOBAL_HAC_ENABLED", "GlobalHACEnabled" );
    define( "SL_BROWSE_HAC_DEFAULT", "BrowseHACDefault" );
    define( "SL_STREAM_HAC_DEFAULT", "StreamHACDefault" );
    define( "SL_DOWNLOAD_HAC_DEFAULT", "DownloadHACDefault" );
    define( "SL_GLOBAL_HAC_DEFAULT", "GlobalHACDefault" );
    
    // Agent Access Control Options
    define( "SL_BROWSE_AAC_ENABLED", "BrowseAACEnabled" );
    define( "SL_STREAM_AAC_ENABLED", "StreamAACEnabled" );
    define( "SL_DOWNLOAD_AAC_ENABLED", "DownloadAACEnabled" );
    define( "SL_BROWSE_AAC_MODE", "BrowseAACMode" );
    define( "SL_STREAM_AAC_MODE", "StreamAACMode" );
    define( "SL_DOWNLOAD_AAC_MODE", "DownloadAACMode" );
    
    // Logging Setup
    define( "SL_LOG_BROWSE", "LogBroswing" );
    define( "SL_LOG_STREAM", "LogStreaming" );
    define( "SL_LOG_DOWNLOAD", "LogDownloading" );

    // Version
    define( "SL_VERSION", "SLVersion" );
    
    class SLConfiguration
    {
        var $options;
        
        function SLConfiguration()
        {
            $this->options = array(
                SL_WEB_SERVER_ROOT => "",
                SL_MEDIA_SERVER_ROOT => "",
                SL_MEDIA_ROOT => "",
                SL_THEME => "",
                SL_SERVER_TITLE => "",
                SL_BROWSING_REQUIRES_AUTH => true,
                SL_STREAMING_REQUIRES_AUTH => true,
                SL_DOWNLOADING_REQUIRES_AUTH => true,
                SL_ADMIN_REQUIRES_AUTH => true,
                SL_BROWSER_COLUMNS => array(),
                SL_STREAM_FORMAT => array(),
                SL_SORT_ORDER => array(),
                SL_BROWSE_HAC_ENABLED => "false",
                SL_STREAM_HAC_ENABLED => "false",
                SL_DOWNLOAD_HAC_ENABLED => "false",
                SL_GLOBAL_HAC_ENABLED => "false",
                SL_BROWSE_HAC_DEFAULT => "allow",
                SL_STREAM_HAC_DEFAULT => "allow",
                SL_DOWNLOAD_HAC_DEFAULT => "allow",
                SL_GLOBAL_HAC_DEFAULT => "allow",
                SL_BROWSE_AAC_ENABLED => "false",
                SL_STREAM_AAC_ENABLED => "false",
                SL_DOWNLOAD_AAC_ENABLED => "false",
                SL_BROWSE_AAC_MODE => "allow",
                SL_STREAM_AAC_MODE => "allow",
                SL_DOWNLOAD_AAC_MODE => "allow",
                SL_LOG_BROWSE => true,
                SL_LOG_STREAM => true,
                SL_LOG_DOWNLOAD => true,
                SL_MASK_URLS => true,
                SL_VERSION => ""
            );

        }
        
        function getOptionsArray()
        {
            return $this->options;
        }

        
        function setWebServerRoot( $wsr )
        {
            $this->options[SL_WEB_SERVER_ROOT] = $wsr;
        }

        function getWebServerRoot()
        {
            return $this->options[SL_WEB_SERVER_ROOT];
        }


        function setMediaServerRoot( $msr )
        {
            $this->options[SL_MEDIA_SERVER_ROOT] = $msr;
        }

        function getMediaServerRoot()
        {
            return $this->options[SL_MEDIA_SERVER_ROOT];
        }


        function setMediaRoot( $mr )
        {
            $this->options[SL_MEDIA_ROOT] = $mr;
        }

        function getMediaRoot()
        {
            return $this->options[SL_MEDIA_ROOT];
        }

        
        function setTheme( $theme )
        {
            $this->options[SL_THEME] = $theme;
        }

        function getTheme()
        {
            return $this->options[SL_THEME];
        }

        
        function setServerTitle( $title )
        {
            $this->options[SL_SERVER_TITLE] = $title;
        }

        function getServerTitle()
        {
            return $this->options[SL_SERVER_TITLE];
        }

       
       function setBrowsingRequiresAuth( $req_auth )
        {
            $this->options[SL_BROWSING_REQUIRES_AUTH] = $req_auth;
        }

        function getBrowsingRequiresAuth()
        {
            return $this->options[SL_BROWSING_REQUIRES_AUTH];
        }

        
        function setStreamingRequiresAuth( $req_auth )
        {
            $this->options[SL_STREAMING_REQUIRES_AUTH] = $req_auth;
        }

        function getStreamingRequiresAuth()
        {
            return $this->options[SL_STREAMING_REQUIRES_AUTH];
        }

        
        function setDownloadingRequiresAuth( $req_auth )
        {
            $this->options[SL_DOWNLOADING_REQUIRES_AUTH] = $req_auth;
        }

        function getDownloadingRequiresAuth()
        {
            return $this->options[SL_DOWNLOADING_REQUIRES_AUTH];
        }


        function setAdminRequiresAuth( $req_auth )
        {
            $this->options[SL_ADMIN_REQUIRES_AUTH] = $req_auth;
        }

        function getAdminRequiresAuth()
        {
            return $this->options[SL_ADMIN_REQUIRES_AUTH];
        }


        function getSLVersion()
        {
            return $this->options[SL_VERSION];
        }

        function setSLVersion( $version )
        {
            $this->options[SL_VERSION] = $version;
        }

        
        function setBrowserColumns( $bFormat )
        {
            if ( !is_array( $bFormat ) )
            {
                $temp = explode( ",", $bFormat );
                $array = array();

                foreach ( $temp as $t )
                {
                    $array[$t] = $t;
                }
            }
            else
            {
                $array = $bFormat;
            }
            
            $this->options[SL_BROWSER_COLUMNS] = $array;
        }

        function getBrowserColumns()
        {
            return $this->options[SL_BROWSER_COLUMNS];
        }

        
        function setStreamFormat( $sFormat )
        {
            if ( !is_array( $sFormat ) )
            {
                $array = $this->processFormatString( $sFormat );
            }
            else
            {
                $array = $sFormat;
            }
            
            $this->options[SL_STREAM_FORMAT] = $array;
        }

        function getStreamFormat()
        {
            return $this->options[SL_STREAM_FORMAT];
        }

        
        function setSortOrder( $sort )
        {
            if ( !is_array( $sort ) )
            {
                $temp = explode( ",", $sort );
                $array = array();

                foreach ( $temp as $t )
                {
                    $array[$t] = $t;
                }
            }
            else
            {
                $array = $sort;
            }

            $this->options[SL_SORT_ORDER] = $array;
        }

        function getSortOrder()
        {
            return $this->options[SL_SORT_ORDER];
        }
        
        //
        // HAC Enabled
        //

        function setBrowseHACEnabled( $enabled )
        {
            $this->options[SL_BROWSE_HAC_ENABLED] = $enabled;
        }
        
        function getBrowseHACEnabled()
        {
            return $this->options[SL_BROWSE_HAC_ENABLED];
        }
        
        function setStreamHACEnabled( $enabled )
        {
            $this->options[SL_STREAM_HAC_ENABLED] = $enabled;
        }
        
        function getStreamHACEnabled()
        {
            return $this->options[SL_STREAM_HAC_ENABLED];
        }
        
        function setDownloadHACEnabled( $enabled )
        {
            $this->options[SL_DOWNLOAD_HAC_ENABLED] = $enabled;
        }
        
        function getDownloadHACEnabled()
        {
            return $this->options[SL_DOWNLOAD_HAC_ENABLED];
        }
         
        function setGlobalHACEnabled( $enabled )
        {
            $this->options[SL_GLOBAL_HAC_ENABLED] = $enabled;
        }
        
        function getGlobalHACEnabled()
        {
            return $this->options[SL_GLOBAL_HAC_ENABLED];
        }      
        
        //
        // HAC Defaults
        //

        function setBrowseHACDefault( $default )
        {
            $this->options[SL_BROWSE_HAC_DEFAULT] = $default;
        }
        
        function getBrowseHACDefault()
        {
            return $this->options[SL_BROWSE_HAC_DEFAULT];
        }
        
        function setStreamHACDefault( $default )
        {
            $this->options[SL_STREAM_HAC_DEFAULT] = $default;
        }
        
        function getStreamHACDefault()
        {
            return $this->options[SL_STREAM_HAC_DEFAULT];
        }
        
        function setDownloadHACDefault( $default )
        {
            $this->options[SL_DOWNLOAD_HAC_DEFAULT] = $default;
        }
        
        function getDownloadHACDefault()
        {
            return $this->options[SL_DOWNLOAD_HAC_DEFAULT];
        }
        
        function setGlobalHACDefault( $default )
        {
            $this->options[SL_GLOBAL_HAC_DEFAULT] = $default;
        }
        
        function getGlobalHACDefault()
        {
            return $this->options[SL_GLOBAL_HAC_DEFAULT];
        }
        
        //
        // AAC Enabled
        //
        
        function setBrowseAACEnabled( $enabled )
        {
            $this->options[SL_BROWSE_AAC_ENABLED] = $enabled;
        }
        
        function getBrowseAACEnabled()
        {
            return $this->options[SL_BROWSE_AAC_ENABLED];
        }
        
        function setStreamAACEnabled( $enabled )
        {
            $this->options[SL_STREAM_AAC_ENABLED] = $enabled;
        }
        
        function getStreamAACEnabled()
        {
            return $this->options[SL_STREAM_AAC_ENABLED];
        }
        
        function setDownloadAACEnabled( $enabled )
        {
            $this->options[SL_DOWNLOAD_AAC_ENABLED] = $enabled;
        }
        
        function getDownloadAACEnabled()
        {
            return $this->options[SL_DOWNLOAD_AAC_ENABLED];
        }   


        //
        // AAC Defaults
        //
        
        function setBrowseAACMode( $default )
        {
            $this->options[SL_BROWSE_AAC_MODE] = $default;
        }
        
        function getBrowseAACMode()
        {
            return $this->options[SL_BROWSE_AAC_MODE];
        }
        
        function setStreamAACMode( $default )
        {
            $this->options[SL_STREAM_AAC_MODE] = $default;
        }
        
        function getStreamAACMode()
        {
            return $this->options[SL_STREAM_AAC_MODE];
        }
        
        function setDownloadAACMode( $default )
        {
            $this->options[SL_DOWNLOAD_AAC_MODE] = $default;
        }
        
        function getDownloadAACMode()
        {
            return $this->options[SL_DOWNLOAD_AAC_MODE];
        }

        
        //
        // Logging Setup
        //
              
        function getLogBrowsing()
        {
            return $this->options[SL_LOG_BROWSE];
        }  
        
        function setLogBrowsing( $log )
        {
            $this->options[SL_LOG_BROWSE] = $log;
        }


        function getLogStreaming()
        {
            return $this->options[SL_LOG_STREAM];
        }  
        
        function setLogStreaming( $log )
        {
            $this->options[SL_LOG_STREAM] = $log;
        }
        

        function getLogDownloading()
        {
            return $this->options[SL_LOG_DOWNLOAD];
        }  
        
        function setLogDownloading( $log )
        {
            $this->options[SL_LOG_DOWNLOAD] = $log;
        }

        
        function getMaskURLs()
        {
            return $this->options[SL_MASK_URLS];
        }

        function setMaskURLs( $mask )
        {
            $this->options[SL_MASK_URLS] = $mask;
        }

        
        //
        // Helper Functions
        //

        function processFormatString( $string )
        {
            $result = array();

            while( strlen( $string ) > 0 )
            {
                $index = strpos( $string, "%" );
                
                if ( $index === false )
                {
                    array_push( $result, $string );
                    $string = "";
                }
                else if ( $index == 0 )
                {
                    array_push( $result, substr( $string, 0, 2 ) );
                    $string = substr( $string, 2, strlen( $string ) - 2 );
                }
                else
                {
                    $pre = substr( $string, 0, $index );
                    array_push( $result, $pre );
                    $string = substr( $string, $index, strlen( $string ) - $index );
                }
            }
            
            return $result;
        }
    }   
}
?>
