<?
require_once( "AuthUser.php" );
require_once( "core/streamline_constants.php" );

if ( !defined( "_AUTHENTICATOR" ) ){
      define( "_AUTHENTICATOR", 1 );

    define( "SL_LOGIN_TRIES", "SL_LOGIN_TRIES" );

    class Authenticator 
    {
        
        //
        // Tells you if there is currently a user logged in.
        //
        function isLoggedIn()
        {
            return array_key_exists( SL_AUTH_USER, $_SESSION ) && isset( $_SESSION[SL_AUTH_USER] );
        }
        
        
        // 
        // This method will atempt to find a mathcing username and password.
        // If it does it will set the appropriate session info to log the
        // user in.
        //
        function login( $request_uname, $request_pass, $db )
        {
            $auth = false;

            if ( $this->isLoggedIn() )
            {
              echo "Already logged in!!!";
              die();
            }
            
            if ( isset( $request_uname ) && isset( $request_pass ) )
            {
                require_once( "core/db/tables/SLUserTable.php" );
                $user_table = new SLUserTable( $db );
                $user = $user_table->getUserByName( $request_uname );
                
                if ( $user != null )
                {
                    $hash = $user->getPasswordHash();
                    $salt = substr( $hash , 0 , 2 );
                    $enc_pw = crypt( $request_pass, $salt );
                    $a_flag = $user->getAdminFlag();
                    $auth = ( $hash == $enc_pw );
                }
            
                if ( $auth )
                {
                    $auth_user = new AuthUser( $user->getUserId(), $user->getPasswordHash(), $request_uname, $request_pass );
                    $_SESSION[SL_AUTH_USER] = $auth_user;
                    
                    // Revaluate Access Base on the new user.
                    global $sl_access_controler;
                    global $sl_config;

                    $sl_access_controler->setUserId( $user->getUserId() );
                    $sl_access_controler->evaluate( $db, $sl_config );
                    
                    require_once( "core/db/tables/SLLastLoginTable.php" );
                    $login_table = new SLLastLoginTable( $db );

                    if ( !$login_table->lastLoginExists( $user->getUserId() ) )
                    {
                        $login_table->addLastLoginForUser( $user->getUserId(), time(), gethostbyaddr( $_SERVER['REMOTE_ADDR'] ) );
                        $last_login = $login_table->getLastLoginForUid( $user->getUserId() );

                        $_SESSION[SL_LAST_LOGIN] = new LastLoginInfo( 
                            $last_login->getUID(), $last_login->getTime(), $last_login->getHost() );
                    }
                    else
                    {
                        $last_login = $login_table->getLastLoginForUid( $user->getUserId() );
                        
                        $_SESSION[SL_LAST_LOGIN] = new LastLoginInfo( 
                            $last_login->getUID(), $last_login->getTime(), $last_login->getHost() );
                        
                        $last_login->setTime( time() );
                        $last_login->setHost( gethostbyaddr( $_SERVER['REMOTE_ADDR'] ) );
                        $last_login->store();
                    }
                }
            }

            return $auth;
        }


        // 
        // This method will take the currently set session user info and ensure
        // that user and password are valid.
        //
        function validateUser( $db )
        {
            $auth = false;
            
            $auth_user = $_SESSION[SL_AUTH_USER];
            if ( isset( $auth_user  ) )
            {
                require_once( "core/db/tables/SLUserTable.php" );
                $user_table = new SLUserTable( $db );
                $user = $user_table->getUserById( $auth_user->getUID() );
                
                if ( $user != null )
                {
                    $hash1 = $auth_user->getPasswordHash(); 
                    $hash2 = $user->getPasswordHash();
                    $auth = ( $hash1 == $hash2 );
                }
            }
            else
            {
                echo "You are not logged in";
                die();
            }

            return $auth;
        }


        // 
        // This method will clear the authentication info from the session.
        //
        function logOut()
        {
            $_SESSION[SL_AUTH_USER] = null;
            
            global $sl_access_controler;
            global $sl_config;
            $sl_access_controler->setUserId( null );
            $sl_access_controler->evaluate( $db, $sl_config );
        }
    }
}
?>
