<?php

if ( !defined( "_SL_DIR_INFO" ) ){
      define( "_SL_DIR_INFO", 1 );

    class SLDirInfo
    {
        var $dir_name;
        var $rel_path;
        var $server_root;
        var $mask_urls;

        function SLDirInfo( $dir_name, $server_root, $rel_path, $mask_urls )
        {
            $this->rel_path = $rel_path;
            $this->server_root = $server_root;
            $this->mask_urls = $mask_urls;
            $this->dir_name = $dir_name;
        }

        function getDirName()
        {
            return $this->dir_name;
        }

        function getRelativePath()
        {
            return $this->rel_path;
        }
        
        
        function getBrowsePath()
        {
            if ( $this->mask_urls )
            {
                $browse_root = joinURLPath( $this->server_root, "browse");
            }
            else
            {
                $browse_root = joinURLPath( $this->server_root, "browse/index.php?dir=");
            }
            
            return joinURLPath( $browse_root, $this->rel_path );
        }

        function getM3UPath()
        {
            if ( $this->mask_urls )
            {
                $m3u_root = joinURLPath( $this->server_root, "m3u");
            }
            else
            {
                $m3u_root = joinURLPath( $this->server_root, "m3u/index.php?media=");
            }

            return joinURLPath( $m3u_root, joinURLPath( $this->rel_path, "/play_all.m3u" ) );
        }

    }
}
?>
