<?php

if ( !defined( "_SL_MEDIA_INFO" ) ){
      define( "_SL_MEDIA_INFO", 1 );

    class SLMediaInfo
    {
        var $rel_path;
        var $server_root;
        var $media_info;
        var $mask_urls;

        function SLMediaInfo( $server_root, $rel_path, $mask_urls, &$media_info )
        {
            $this->rel_path = $rel_path;
            $this->server_root = $server_root;
            $this->media_info = &$media_info;
            $this->mask_urls = $mask_urls;
        }

        function getRelativePath()
        {
            return $this->rel_path;
        }
        
        function getStreamPath()
        {
            if ( $this->mask_urls )
            {
                $stream_root = joinURLPath( $this->server_root, "stream");
            }
            else
            {
                $stream_root = joinURLPath( $this->server_root, "stream/index.php?media=");
            }
            
            return joinURLPath( $stream_root, $this->rel_path );
        }

        function getM3UPath()
        {
            if ( $this->mask_urls )
            {
                $m3u_root = joinURLPath( $this->server_root, "m3u");
            }
            else
            {
                $m3u_root = joinURLPath( $this->server_root, "m3u/index.php?media=");
            }

            return joinURLPath( $m3u_root, $this->rel_path );
        }

        function getInfoPath()
        {
            if ( $this->mask_urls )
            {
                $info_root = joinURLPath( $this->server_root, "info");
            }
            else
            {
                $info_root = joinURLPath( $this->server_root, "info/index.php?media=");
            }

            return joinURLPath( $info_root, $this->rel_path );
        }
        
        function getDownloadPath()
        {
            if ( $this->mask_urls )
            {
                $dl_root = joinURLPath( $this->server_root, "download");
            }
            else
            {
                $dl_root = joinURLPath( $this->server_root, "download/index.php?media=");
            }
            return joinURLPath( $dl_root, $this->rel_path );
        }

        function getInfo()
        {
            return $this->media_info;
        }
    }
}
?>
