<?php
if ( !defined( "_SL_DATA_BASE" ) ){
      define( "_SL_DATA_BASE", 1 );
      
    class SLDataBase
    {
        var $db;
        var $host;
        var $user;
        var $pass;
        var $dbname;
        var $error;
        var $lastResult;

        function SLDataBase( $host, $user, $pass, $dbname )
        {
            $this->host = $host;
            $this->user = $user;
            $this->pass = $pass;
            $this->dbname = $dbname;
        }
    
        
        function connect()
        {
            $result = false;
           
            $host = $this->host;
            $user = $this->user;
            $pass = $this->pass;
            $name = $this->dbname;
            
            $conn_string = "host=$host dbname=$name user=$user password=$pass";
            $conn = @pg_connect($conn_string);

            if ( is_resource( $conn ) )
            {
                $this->db = $conn;
                $result = true;
            }
            else
            {
               $this->error = "Could not connect to the PostgreSQL database '".$this->dbname."'.";
            }

            return $result;
        }

        function close()
        {
            @pg_close( $this->db );
        }

        function createDataBase()
        {
            $host = $this->host;
            $user = $this->user;
            $pass = $this->pass;
            $name = $this->dbname;

            $conn_string = "host=$host dbname=template1 user=$user password=$pass";
            $conn = @pg_connect($conn_string);

            $qr = false;
            
            if ( is_resource( $conn ) )
            {
                $sql = "CREATE DATABASE $name";
                $qr = @pg_query( $conn, $sql );

                if ( !$qr )
                {
                    $pg_last_error = @pg_last_error( $conn );
                    $this->error = "Could not create data base with the SQL statement: $sql\n$pg_last_error";
                }

                pg_close( $conn );
            }
            else
            {
                $this->error = "Could not connect to postgresql dbms to create database.";
            }
            
            return $qr;
        }
        
        function getError()
        {
            return $this->error;
        }

        function query( $sql )
        {
            // Escape any single slashes.
            $sql = str_replace( "\\", "\\\\", $sql );
            $qr = @pg_query( $this->db, $sql );
            
            $result = true;
            if ( is_resource( $qr ) )
            {
                $this->lastResult = array();
                
                while( $row = pg_fetch_assoc( $qr ) )
                {
                    array_push( $this->lastResult, $row );
                }
            }
            else if ( $qr )
            {
                $result = $qr;
            }
            else
            {
                $this->error = pg_last_error( $this->db );
                $result = false;
            }
            
            return $result;
        }

        function getLastResult()
        {
            return $this->lastResult;
        }
    }
}
?>
