<?php
require_once( "core/db/util/SQLStatement.php" );
require_once( "core/db/constants/SLAACConstants.php" );

if ( !defined( "_SL_AAC_ENTRY" ) ){
      define( "_SL_AAC_ENTRY", 1 );

    
    class SLAACEntry 
    {
        var $db;
        var $entryid;
        var $pattern;
        var $rule;
        var $service;
        var $p_type;
        
        function SLAACEntry( $db, $entryid )
        {
            $this->db = $db;
            $this->entryid = $entryid;
            $this->load();
        }

        function getEntryId()
        {
            return $this->entryid;
        }

        function getPatternType()
        {
            return $this->p_type;
        }

        function getPattern()
        {
            return $this->pattern;
        }

        
        function getRule()
        {
            return $this->rule;
        }

        function setRule( $rule )
        {
            $this->rule = $rule;
        }


        function getService()
        {
            return $this->service;
        }

        function setService( $service )
        {
            $this->service = $service;
        }


        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM agent_access WHERE entryid = ?" );
            $sql->setValue( 0, $this->entryid );

            $this->db->query( $sql->toSQL()  );
            $rows = $this->db->getLastResult();
            $row = $rows[0];

            $this->pattern = $row['pattern'];
            $this->rule = $row['rule'];
            $this->service = $row['service'];
            $this->p_type = $row['ptype'];
        }

        
        function store()
        {
            $sql = SQLStatement::createStatement( 
                "UPDATE agent_access SET pattern = ?, rule = ?, service = ?, ptype = ? WHERE entryid = ?" 
            );

            $sql->setValue( 0, addslashes( $this->start ) );
            $sql->setValue( 1, addslashes( $this->rule ) );
            $sql->setValue( 2, addslashes( $this->service ) );
            $sql->setValue( 3, addslashes( $this->p_type ) );
            $sql->setValue( 4, addslashes( $this->entryid ) );
            
            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
