<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_CONFIG_OPTION" ) ){
      define( "_SL_CONFIG_OPTION", 1 );

    class SLConfigOption 
    {
        var $db;
        var $name;
        
        function SLConfigOption( $db, $name )
        {
            $this->db = $db;
            $this->name = $name;
        }

        function getName()
        {
            return $this->name;
        }

        function getValue()
        {
            $sql = SQLStatement::createStatement( "SELECT value FROM config WHERE name = ?" );
            $sql->setValue( 0, $this->name );
            
            $this->db->query( $sql->toSQL() );
            $rows = $this->db->getLastResult();

            return $rows[0]["value"];

        }

        function setValue( $value )
        {
            $sql = SQLStatement::createStatement( "UPDATE config SET value = ? WHERE name = ?" );
            $sql->setValue( 0, $value );
            $sql->setValue( 1, $this->name );
            $result = $this->db->query( $sql->toSQL()  );

            return $result;
        }
    }
}
?>
