<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_PL_ENTRY" ) ){
      define( "_SL_PL_ENTRY", 1 );

    class SLPLEntry 
    {
        var $db;
        var $entryid;
        
        var $listid;
        var $index;
        var $media;
        
        function SLPLEntry( $db, $entryid )
        {
            $this->db = $db;
            $this->entryid = $entryid;
            $this->load();
        }

        function getEntryID()
        {
            return $this->entryid;
        }
        
        function getListID()
        {
            return $this->listid;
        }
        
        function setListID( $listid )
        {
             $this->listid = $listid;
        }
        
        function getIndex()
        {
            return $this->index;
        }

        function setIndex( $index )
        {
            $this->index = $index;
        }

        function getMedia()
        {
            return $this->media;
        }

        function setMedia( $media )
        {
            $this->media = $media;
        }

        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM plentry WHERE entryid = ?" );
            $sql->setValue( 0, $this->entryid );
            
            $this->db->query( $sql->toSQL()  );
            $rows = $this->db->getLastResult();
            $row = $rows[0];

            $this->listid = $row['listid'];
            $this->index = $row['ndx'];
            $this->media = $row['media'];
        }

        
        function store()
        {
            $sql = SQLStatement::createStatement( 
                "UPDATE plentry SET listid = ?, ndx = ?, media = ? WHERE entryid = ?" 
            );

            $sql->setValue( 0, $this->listid );
            $sql->setValue( 1, $this->index );
            $sql->setValue( 2, $this->media );
            $sql->setValue( 3, $this->entryid );
            
            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
