<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_PLAY_LIST" ) ){
      define( "_SL_PLAY_LIST", 1 );

    class SLPlayList 
    {
        var $db;
        var $listid;
        
        var $uid;
        var $title;
        
        function SLPlayList( $db, $listid )
        {
            $this->db = $db;
            $this->listid = $listid;
            $this->load();
        }

        function getListID()
        {
            return $this->listid;
        }
        
        function getUserID()
        {
            return $this->uid;
        }
        
        function setUserID( $uid )
        {
             $this->uid = $uid;
        }
        
        function getTitle()
        {
            return $this->title;
        }

        function setTitle( $title )
        {
            $this->title = $title;
        }


        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM playlists WHERE listid = ?" );
            $sql->setValue( 0, $this->listid );
            
            $this->db->query( $sql->toSQL() );
            
            $rows = $this->db->getLastResult();
            $row = $rows[0];
            
            $this->uid = $row['uid'];
            $this->title = $row['title'];
        }

        
        function store()
        {
            $sql = SQLStatement::createStatement( 
                "UPDATE playlists SET uid = ?, title = ? WHERE listid = ?" 
            );

            $sql->setValue( 0, $this->uid );
            $sql->setValue( 1, $this->title );
            $sql->setValue( 2, $this->listid );
            
            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
