<?php

require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_USER" ) ){
      define( "_SL_USER", 1 );

    class SLUser 
    {
        var $db;
        var $uid;

        var $uname;
        var $fname;
        var $lname;
        var $email;
        var $pass;
        var $stream;
        var $browse;
        var $download;
        var $admin;
        var $xmms_cmpt;
        
        function SLUser( $db, $userid )
        {
            $this->db = $db;
            $this->uid = $userid;
            $this->load();
        }

        function getUserId()
        {
            return $this->uid;
        }

        function getUserName()
        {
            return $this->uname;
        }

        function getFirstName()
        {
            return $this->fname;
        }

        function setFirstName( $fname )
        {
            $this->fname = $fname;
        }

        function getLastName()
        {
            return $this->lname;
        }

        function setLastName( $lname )
        {
            $this->lname = $lname;
        }

        function getEmail()
        {
            return $this->email;
        }

        function setEmail( $email )
        {
            $this->email = $email;
        }

        function getXMMSCompatibility()
        {
            return $this->xmms_cmpt;
        }

        function setXMMSCompatibility( $xmms_cmpt )
        {
            $this->xmms_cmpt = $xmms_cmpt?1:0;
        }

        function getPasswordHash()
        {
            return $this->pass;
        }

        function setPasswordHash( $phash )
        {
            $this->pass = $phash;
        }

        function setPassword( $pass )
        {
            $rand64= "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
            $random=rand();
            $salt=substr($rand64,$random  %  64,1).substr($rand64,($random/64) % 64,1);
            $hash = crypt( $pass, $salt );
            $this->pass = $hash;
        }


        function getBrowse()
        {
            return $this->browse == 1;
        }

        function setBrowse( $browse )
        {
            $this->browse = $browse?1:0;
        }

        function getStream()
        {
            return $this->stream == 1;
        }

        function setStream( $stream )
        {
            $this->stream = $stream?1:0;
        }

        function getDownload()
        {
            return $this->download == 1;
        }

        function setDownload( $download )
        {
            $this->download = $download?1:0;
        }
        
        
        function getAdminFlag()
        {
            return $this->admin == 1;
        }

        function setAdminFlag( $flag )
        {
            $this->admin = $flag?1:0;
        }
        
        function load()
        {
            $sql = SQLStatement::createStatement( "SELECT * FROM users WHERE uid = ?" );
            $sql->setValue( 0, $this->uid );
            
            $this->db->query( $sql->toSQL() );
            $rows = $this->db->getLastResult();
            $row = $rows[0];

            $this->uname = $row['uname'];
            $this->fname = $row['fname'];
            $this->lname = $row['lname'];
            $this->email = $row['email'];
            $this->pass = $row['password'];
            $this->xmms_cmpt = $row['xmmscmpt'];
            $this->admin = intval($row['admin']);
            $this->browse = intval($row['browse']);
            $this->stream = intval($row['stream']);
            $this->download = intval($row['download']);
        }

        function store()
        {
            $sql = SQLStatement::createStatement( 
                "UPDATE users SET password = ?, fname = ?, lname = ?, email = ?, browse = ?, stream = ?,".
                "download = ?, admin = ?, xmmscmpt = ? WHERE uid = ?" 
            );

            $sql->setValue( 0, $this->pass );
            $sql->setValue( 1, $this->fname );
            $sql->setValue( 2, $this->lname );
            $sql->setValue( 3, $this->email );
            $sql->setValue( 4, $this->browse );
            $sql->setValue( 5, $this->stream );
            $sql->setValue( 6, $this->download );
            $sql->setValue( 7, $this->admin );
            $sql->setValue( 8, $this->xmms_cmpt );
            $sql->setValue( 9, $this->uid );

            return $this->db->query( $sql->toSQL() );
        }
    }
}
?>
