<?php

require_once( "core/db/objects/SLAACEntry.php" );
require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_AAC_TABLE" ) ){
      define( "_SL_AAC_TABLE", 1 );

    class SLAACTable
    {
        var $db;

        function SLAACTable( $db )
        {
            $this->db = $db;
        }

        
        function createAACEntry( $ptype, $pattern, $rule, $service )
        {
            $template = "INSERT INTO agent_access (ptype, pattern, rule, service) VALUES ( ?, ?, ?, ? )";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $ptype );
            $sql->setValue( 1, $pattern );
            $sql->setValue( 2, $rule );
            $sql->setValue( 3, $service );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }


        function deleteAACEntryById( $entryid )
        {
            $template = "DELETE FROM agent_access WHERE entryid = ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $entryid );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }

        

        function getEntriesByServiceAndRule( $service, $rule )
        {
            $result = null;
            
            $template = "SELECT entryid FROM agent_access WHERE service = ? AND rule = ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $service );
            $sql->setValue( 1, $rule );
            
            $qr = $this->db->query( $sql->toSQL() );

            if ( $qr )
            {
                $result = array();
                $rows = $this->db->getLastResult();
                if ( is_array( $rows ) )
                {
                    foreach( $rows as $row )
                    {
                        array_push( $result, new SLAACEntry( $this->db, $row['entryid'] ) );
                    }
                }
            }

            return $result;
        }
    }
}
?>
