<?php

require_once( "core/db/objects/SLHACEntry.php" );
require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_HAC_TABLE" ) ){
      define( "_SL_HAC_TABLE", 1 );

    class SLHACTable
    {
        var $db;

        function SLHACTable( $db )
        {
            $this->db = $db;
        }

        
        function createHACEntry( $startip, $endip, $rule, $service )
        {
            $template ="INSERT INTO host_access (startip, endip, rule, service) VALUES ( ?, ?, ?, ?  )";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $startip );
            $sql->setValue( 1, $endip );
            $sql->setValue( 2, $rule );
            $sql->setValue( 3, $service );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }


        function deleteHACEntry( $startip, $endip, $rule, $service )
        {
            $template ="DELETE FROM host_access WHERE startip = ? AND endip = ? AND rule = ? AND service = ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $startip );
            $sql->setValue( 1, $endip );
            $sql->setValue( 2, $rule );
            $sql->setValue( 3, $service );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }

        function deleteHACEntryById( $entryid )
        {
            $template ="DELETE FROM host_access WHERE entryid = ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $entryid );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }

        

        function getEntriesByServiceAndRule( $service, $rule )
        {
            $result = null;
            
            $template = "SELECT entryid FROM host_access WHERE service = ? AND rule = ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $service );
            $sql->setValue( 1, $rule );
            
            $qr = $this->db->query( $sql->toSQL() );
            
            if ( $qr )
            {
                $result = array();
                $rows = $this->db->getLastResult();
                if ( is_array( $rows ) )
                {
                    foreach( $rows as $row )
                    {
                        array_push( $result, new SLHACEntry( $this->db, $row['entryid'] ) );
                    }
                }
            }

            return $result;
        }
    }
}
?>
