<?
require_once( "core/db/objects/SLPLEntry.php" );
require_once( "core/db/util/SQLStatement.php" );

if ( !defined( "_SL_PL_ENTRY_TABLE" ) ){
      define( "_SL_PL_ENTRY_TABLE", 1 );

    class SLPLEntryTable
    {
        var $db;

        function SLPLEntryTable( $db )
        {
            $this->db = $db;
        }

        
        function createPLEntry( $listid, $index, $media )
        {
            $template = "INSERT INTO plentry ( listid, ndx, media ) VALUES ( ?, ?, ? )";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $listid );
            $sql->setValue( 1, $index );
            $sql->setValue( 2, $media );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }

        function deletePLEntry( $entryid )
        {
            $template ="DELETE FROM plentry WHERE entryid = ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $entryid );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }

        function deletePLEntriesForListID( $listid )
        {
            $template ="DELETE FROM plentry WHERE listid = ?";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $listid );
            
            $result = $this->db->query( $sql->toSQL() );
            return $result;
        }

        function removeEntriesForListIDsNot( $list_ids )
        {
            $where_clause = "(";
            
            $count = count( $list_ids );
      
            for ( $i = 0; $i < $count; $i++ )
            {
                if ( $where_clause != "(" )
                {
                    $where_clause .= " OR ";
                }
                
                $where_clause .= "listid = ?";
            }

            $where_clause .= ")";

            $where = SQLStatement::createStatement( $where_clause );
            
            for ( $i = 0; $i < $count; $i++ )
            {
                $where->setValue( $i, $list_ids[$i] );
            }

            $where_sql = $where->toSQL();
            $sql = "DELETE FROM plentry WHERE NOT $where_sql";
            $result = $this->db->query( $sql );

            return $result;
        }

        function getPLEntryForListIDByIndex( $listid )
        {
            $result = null;
            
            $template = "SELECT entryid FROM plentry WHERE listid = ? ORDER BY ndx";
            $sql = SQLStatement::createStatement( $template );
            $sql->setValue( 0, $listid );
            
            $qr = $this->db->query( $sql->toSQL() );

            if ( $qr )
            {
                $result = array();
                $rows = $this->db->getLastResult();
                                                
                foreach( $rows as $row )
                {
                    array_push( $result, new SLPLEntry( $this->db, $row['entryid'] ) );
                }
            }

            return $result;
        }


        function getAllPLEntrys()
        {
            $qr = $this->db->query( "SELECT entryid FROM plentry" );

            if ( $qr )
            {
                $result = array();
                $rows = $this->db->getLastResult();
                
                foreach( $rows as $row )
                {
                    array_push( $result, new SLPLEntry( $this->db, $row['entryid'] ) );
                }    
            }
            
            return $result;
        }
    }
}
?>
