<?
require_once( "core/streamline_functions.php" );
require_once( "core/media_info/MediaInfoCache.php" );

if ( !defined( "_MEDIA_INFO_CACHE_MAINTAINER" ) ){
      define( "_MEDIA_INFO_CACHE_MAINTAINER", 1 );

    
    class MediaInfoCacheMaintainer 
    {
        var $cache;
        var $testcount;
        var $media_root;
        var $media_root_len;
        var $cache_root_len;
        var $pruned;

        function MediaInfoCacheMaintainer( $media_root )
        {
            $this->cache = new MediaInfoCache( $media_root );
            $this->media_root = $media_root;
            $this->media_root_len = strlen( $media_root );
            $this->cache_root_len = strlen( $this->cache->getCachePath() );
        }
    
        function update()
        {
            $this->do_update( $this->media_root );
        }
        
        
        function do_update( $file )
        {
            set_time_limit( 20 );
            $dir = opendir( $file );
            
            while ( false !== ( $afile = readdir($dir) ) ) 
            {
                if( $afile == "." || $afile == ".." )
                {
                    continue;
                }

                $cur_file = joinFilePath( $file, $afile );

                if ( is_dir( $cur_file )  )
                {
                    $this->do_update( $cur_file ); 
                }
                else if ( is_file( $cur_file )  )
                {   
                    $tmp_array = explode( ".", $cur_file );
                    $ext = array_pop( $tmp_array );
                   
                    global $sl_media_types;
                    
                    if ( array_key_exists( $ext, $sl_media_types ) )
                    {
                        $rel_path = substr( $cur_file, $this->media_root_len - strlen( $cur_file ) );
                        echo "Updating Media Info Cache for $rel_path ... ";
                        flush();
                        $tag = $this->cache->getMediaInfo( $rel_path  );
                        echo "Done.<br>";
                        flush();
                    }
                }
            }
        }

        function prune()
        {
            $this->pruned = array();
            $this->do_prune( $this->cache->getCachePath() );
        }

        function do_prune( $file )
        {
            set_time_limit( 20 );
            $dir = opendir( $file );
            
            while ( false !== ( $afile = readdir($dir) ) ) 
            {
                if( $afile == "." || $afile == ".." )
                {
                    continue;
                }

                $cur_file = joinFilePath( $file, $afile );

                if ( is_dir( $cur_file )  )
                {
                    $this->do_prune( $cur_file ); 
                }
                else if ( is_file( $cur_file )  )
                {   
                    $rel_path = substr( $cur_file, $this->cache_root_len - strlen( $cur_file ) );
                    
                    echo "Examining file: $rel_path... ";
                    
                    $media_path = joinFilePath( $this->media_root, $rel_path );

                    if ( !is_file( $media_path ) )
                    {
                        echo " &lt;Removed&gt; Deleting Cache Entry.<br>";
                        array_push( $this->pruned, $cur_file );
                        unlink( $cur_file );
                    }
                    else
                    {
                       echo " &lt;OK&gt;<br>";
                    }
                }
            }
        }

        function getPruned()
        {
            return $this->pruned;
        }
    }
}
?>
