<?
    
if ( !defined( "_GENERIC_AUDIO_INFO_PARSER" ) ){
      define( "_GENERIC_AUDIO_INFO_PARSER", 1 );

    class GenericAudioInfoParser 
    {
        var $info;
        var $audio;

        var $comments;
        
        function GenericAudioInfoParser( &$info )
        {
            $this->info = &$info;
            $this->audio = &$info['audio']; 
        }
        
        // Generic File Info
        
        function getMimeType()
        {
            return $this->info["mime_type"];
        }

        function getFileName()
        {
            return $this->info["filename"];
        }
        
        
        // Generic Audio Info
        
        function getBitrate()
        {
            $bitrate = $this->audio["bitrate"];
            $bitrate = $bitrate / 1000;
            $bitrate = "~".round( $bitrate, 2 );
            
            return $bitrate;
        }

        function getSampleRate()
        {
            return $this->audio["sample_rate"];
        }
        
        function getChannels()
        {
            return $this->audio["channelmode"];
        }


        function getLength()
        {
            return $this->info["playtime_string"];
        }

        function getSeconds()
        {
            return $this->info["playtime_seconds"];
        }

        
        // Abstract Comment Info Methods.
        function getArtist() { return "";  }
        
        function getTitle() { return $this->getFileName(); }
        
        function getAlbum() { return ""; }
        
        function getTrack() { return ""; }
        
        function getYear() { return ""; }
        
        function getGenre() { return ""; }
        
        // 
        // This method will print out the raw structure we got back from the
        // getid3 package.
        // 
        function echoDebug()
        {
            echo "<pre>";
            print_r( $this->info );
            echo  "</pre>";
        }
    }
}
?>
