<?
require_once( "core/db/tables/SLMediaStatsTable.php" );

if ( !defined( "_SL_MEDIA_STATS_ENGINE" ) ){
      define( "_SL_MEDIA_STATS_ENGINE", 1 );

    class SLMediaStatsEngine
    {
        var $db;
        var $table;

        function SLMediaStatsEngine( $db )
        {
            $this->db = &$db;
            $this->table = &new SLMediaStatsTable( $this->db );
        }

        function logStream( $path )
        {
            $stat = null;
            
            if ( !$this->table->statsExistForMedia( $path ) )
            {
                $stat = $this->table->createMediaStats( $path );
            } 
            
            $stat = $this->table->getStatsForMedia( $path );
            $stat->incrementStreams();
            $stat->store();
        }


        function getTopMediaRankedByStreams( $num, $offset = 0)
        {
            $result = array();
            $stats = $this->table->getTopRankedMediaByStreams( $num );
            
            foreach( $stats as $stat )
            {
                $result[$stat->getPath()] = $stat->getStreams();
            }

            return $result;
        }
       

        function logDownload( $path )
        {
            $stat = null;
            
            if ( !$this->table->statsExistForMedia( $path ) )
            {
                $stat = $this->table->createMediaStats( $path );
            } 
            
            $stat = $this->table->getStatsForMedia( $path );
            $stat->incrementDownloads();
            $stat->store();
        }
        
        function getTopMediaRankedByDownloads( $num, $offset = 0)
        {
            $result = array();
            $stats = $this->table->getTopRankedMediaByDownloads( $num );
            
            foreach( $stats as $stat )
            {
                $result[$stat->getPath()] = $stat->getDownloads();
            }

            return $result;
        }
    }
}
?>
