<?
require_once( "core/media_info/MediaInfoCacheFile.php" );

if ( !defined( "_STREAMLINE_FUNCTIONS" ) ){
      define( "_STREAMLINE_FUNCTIONS", 1 );
    
 
    function joinURLPath( $root, $path )
    {
        global $sl_platform;

        $path_sep = "/";
        
        if ( $root{ strlen( $root ) - 1 } != $path_sep )
        {
            $root = $root.$path_sep;
        }

        if ( $path{0} == $path_sep )
        {
            $path = substr( $path, 1, strlen( $path ) - 1 );
        }

        return $root.$path;
    }

    function joinFilePath( $root, $path )
    {
        global $sl_platform;

        $path_sep = $sl_platform->getPathSeparator();
        
        if ( $root{ strlen( $root ) - 1 } != $path_sep )
        {
            $root = $root.$path_sep;
        }

        if ( $path{0} == $path_sep )
        {
            $path = substr( $path, 1, strlen( $path ) - 1 );
        }

        return $root.$path;
    }


    function formatID3String( $media_info, $format, $filename )
    {
        $result = "";
        
        $c = count( $format );
        
        for ( $i = 0; $i < $c; $i++ )
        {
            $cur = $format[$i];

            $cur_string = "";
            
            if ( $cur{0} == "%" )
            {
                $code = $cur{1};

                switch ( $code )
                {
                    case '%':
                       $cur_string = "%";
                       break;

                    case "a":
                        $cur_string = $media_info->getArtist();
                        break;
                    
                    case 'f':
                        $cur_string = $filename;
                        break;
                    
                    case "n":
                    
                        $cur_string = $media_info->getTitle();

                        if ( strlen( $cur_string ) <= 0 )
                        {
                            $cur_string = $filename;
                        }
                        break;


                    case 'r':
                        $cur_string = $media_info->getAlbum();
                        break;


                    case 't':
                        $track = $media_info->getTrack();
            
                        if ( $track == -1 )
                        {
                            $cur_string = "??";
                        }
                        else
                        {
                            if ( $track < 10 )
                            {
                                $cur_string = "0".$track;
                            }
                            else
                            {
                                $cur_string = "".$track;
                            }
                        }
                        break;

                    default:
                        break;
                }

            }
            else
            {
                $cur_string .= $cur;
            }
        
            $result .= $cur_string;        
            
        }

        return $result;
    }
    
    function createWebPath( $path )
    {
        $path = normalizeWebPath( $path );

        $array = split( "/", $path );

        for ( $i = 0; $i < count( $array ); $i++ )
        {
            $array[$i] = rawurlencode( $array[$i] );
        }

        return join( "/", $array );
    }
    
    function normalizeWebPath( $path )
    {
        $path = str_replace( "\\", "/", $path );

        $index = strstr( $path, "://" );
        
        $proto = "";
        $loc = "";
        
        if ( $index )
        {
            $proto = $substr( $path, 0, $index );
            $loc = $substr( $path, $index + 3 );
        }
        else
        {
            $loc = $path;
        }

        while( strstr( $loc, "//" ) != false )
        {
            $loc = str_replace( "//", "/", $loc );
        }
        
        return $proto.$loc;
    }

    function outputHTMLLine( $html, $level = 0, $indent = 2 )
    {
       echo "$html\n"; 
    }
}
?>
