<?
require_once( "core/streamline_functions.php" );
require_once( "core/theme/SLTheme.php" );

if ( !defined( "_SL_THEME_MANAGER" ) ){
      define( "_SL_THEME_MANAGER", 1 );

    class SLThemeManager
    {
        var $path;
        var $web_path;
        var $themes;
        
        function SLThemeManager( $theme_path, $web_path )
        {
            $this->path = $theme_path;
            $this->web_path = $web_path;
        }

        function getThemes()
        {
            return $this->themes;
        }
        
        function loadThemes()
        {
            $this->themes = array();
            
            $handle=opendir( $this->path );

            /* This is the correct way to loop over the directory. */
            while (false !== ( $file = readdir($handle) ) ) 
            {
                if( $file == "." || $file == ".." )
                {
                    continue;
                }

                $theme_path = joinFilePath( $this->path, $file );
                $web_path = joinURLPath( $this->web_path, $file );
                
                $info_path = joinFilePath( $theme_path, "theme_info.php" );
                $image_path = joinFilePath( $theme_path, "theme_preview.png" );

                if ( is_file( $info_path ) && is_file( $image_path ) )
                {
                    array_push( $this->themes, new SLTheme( $file, $theme_path, $web_path ) );
                }
            }

        }
    }
 }
?>
