<?
require_once( "core/ui/tables/SLTableModel.php" );

if ( !defined( "_SL_SQL_TABLE_MODEL" ) ){
      define( "_SL_SQL_TABLE_MODEL", 1 );

    class SLSQLTableModel extends SLTableModel
    {
        var $data;
        var $columns;
        var $sql_table;

        var $window;
        var $window_size;
        var $window_start;

        function SLSQLTableModel( &$sql_table, $columns )
        {
            $this->sql_table = &$sql_table;
            $this->columns = $columns;
            $this->window_start = 0;
            $this->window_size = $this->getTotalRows();
        }

        function getTotalRows()
        {
            return $this->sql_table->getNumberOfRows();
        }

        function getNumRows()
        {
            return min( $this->window_size, count( $this->window ) );
        }

        function getNumColumns()
        {
            return count( $this->columns );
        }

        function getColumnName( $index )
        {
            return $this->columns[$index];
        }
        
        function hasNextPage()
        {
            return $this->window_start + $this->window_size < $this->sql_table->getNumberOfRows();
        }

        function hasPreviousPage()
        {
            return $this->window_start > 0;
        }

        function getWindowStart()
        {
            return $this->window_start;
        }

        function getWindowSize()
        {
            return $this->window_size;
        }


        function getValue( $row, $column )
        {
            // This method needs to be overridden.
            return null;
        }
        
        function setWindow( $size, $start )
        {
            $this->window_size = $size;
            $this->window_start = $start;
            // This method needs to be overridden to actually grab the rows.
        }
    }
}
?>
