<?php

require_once( "core/web_server/SLWebServer.php" );

if ( !defined( "_SL_ISAPI" ) ){
      define( "_SL_ISAPI", 1 );

    class SLISAPI extends SLWebServer
    {
        
        function getRequestURI()
        {
            $result = isset( $_SERVER['REQUEST_URI'] )?$_SERVER['REQUEST_URI']:null;

            // If we didn't find this where we would like it to be.  Try a back
            // up plan.
            if ( is_null( $result ) )
            {
                $result = $_SERVER['SCRIPT_NAME'];
                if ( isset( $_SERVER["QUERY_STRING"] ) && $_SERVER["QUERY_STRING"] != "" )
                {
                    $result .= "?";
                    $result .= $_SERVER["QUERY_STRING"];
                }
            }

            return $result;
        }

        function getHTTPRequestHeader( $header_name )
        {
            // Look for things like  _SERVER[HTTP_RANGE];
            $tmp = strtoupper( $header_name );
            $result = isset( $_SERVER[$tmp] )?$_SERVER[$tmp]:null;


            // If we didn't find it try to use the ALL_HTTP var.
            if ( is_null( $result ) )
            {
                $all_http = $_SERVER['ALL_HTTP'];
                $headers = explode( "\n", $all_http );

                $lower = array();
                foreach( $headers as $header )
                {
                    $index = strpos( $header, ":" );
                    $name = substr( $header, 0, $index );
                    $name = substr( $name, 5, strlen( $name ) - 5 );
                    $value = substr( $header, $index + 1, strlen( $header ) - $index + 1 );
                    $lower[strtolower($name)] = $value;
                }

                $header_name = strtolower( $header_name );
            }

            return isset( $lower[$header_name] )?$lower[$header_name]:null;
        }

        function getHTTPAuthUser()
        {
            // Try the PHP_AUTH vars first.
            $result = isset( $_SERVER['PHP_AUTH_USER'] )?$_SERVER['PHP_AUTH_USER']:null;

            // If we didn't get it look in the raw http headers.
            if ( is_null( $result ) )
            {
                $auth_header = $this->getHTTPRequestHeader( 'HTTP_AUTHORIZATION' );
                list($user, $pw) = explode( ':', base64_decode( $auth_header ) );
                $result = $user;
            }
            
            return $result;
        }

        function getHTTPAuthPassword()
        {
            // Try the PHP_AUTH vars first.
            $result = isset( $_SERVER['PHP_AUTH_PW'] )?$_SERVER['PHP_AUTH_PW']:null;

            // If we didn't get it look in the raw http headers.
            if ( is_null( $result ) )
            {
                $auth_header = $this->getHTTPRequestHeader( 'HTTP_AUTHORIZATION' );
                list($user, $pw) = explode( ':', base64_decode( $auth_header ) );
                $result = $pw;
            }
            
            return $result;
        }
    }
}
?>
