<?php
    require_once( "../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "core/streamline_functions.php" );
    require_once( "core/db/db_init.php" );
    require_once( "core/stats/SLDailyStatsEngine.php" );
    require_once( "core/stats/SLMediaStatsEngine.php" );
    require_once( "core/stats/SLUserStatsEngine.php" );


    // Since we use the .htaccess to direct all errors to this page,
    // we should reset the response to return code 200 in case it was
    // set to 404 for a file that doesn't exist.
    header('HTTP/1.1 200\r\n');

    
    if ( $sl_access_controler->requireLoginForDownloading() )
    {
        require_once( "core/auth/php_login.php" );
    }
    
    if ( !$sl_access_controler->getDownloadAccess() )
    {
        $msr = $sl_config->getMediaServerRoot();
        $ad_path = joinURLPath( $msr, "download/access_denied.php" );
        header( "Location: $ad_path" );
        echo "\n";
        die();
    }
   
    
    if ( isset( $_SESSION[SL_AUTH_USER] ) )
    {
        $auth_user = $_SESSION[SL_AUTH_USER];
        
        require_once( "core/db/tables/SLUserTable.php" );
        $sl_user_table = new SLUserTable( $db );
        $sl_user = $sl_user_table->getUserById( $auth_user->getUID() );
        $_user_name = $sl_user->getUserName();
        $user_stats_engine = &new SLUserStatsEngine( $db );
        $user_stats_engine->logDownload( $sl_user->getUserId() );
    }
    else
    {
        $_user_name = "Unknown";
    }

    
    if ( $sl_config->getMaskURLs() )
    {
        $uri = stripslashes( $_SERVER['REQUEST_URI'] );
        $dl_root = joinURLPath( $sl_config->getMediaServerRoot(), "download" );
        $req_path = urldecode( $uri );
        $len = strlen( $req_path );
        $rootlen = strlen( $dl_root );
        $index = strpos( $req_path, $dl_root );
        $rel_path = substr( $req_path, $index + $rootlen, $len - ($index + $rootlen) );
    }
    else
    {
        $rel_path = stripslashes( urldecode( isset( $_REQUEST['media'] )?$_REQUEST['media']:"/" ) );
    }
    
    $media_root = $sl_config->getMediaRoot();
    $media_path = $media_root.$rel_path;
    $file_size = filesize( $media_path );
    
    $tmp = explode( $sl_platform->getPathSeparator(), $rel_path );
    $name = array_pop( $tmp );
    
    header("Content-Disposition: attachment; filename=\"$name\"" );
    header("Content-Length: ".$file_size );
    header("Content-type: audio/mpeg");
    
    
    $media = fopen( $media_path, "r" );

    $sl_logger->logDownload( $rel_path, $_user_name );
    $daily_stats_engine = &new SLDailyStatsEngine( $db );
    $daily_stats_engine->logDownload();
    $media_stats_engine = &new SLMediaStatsEngine( $db );
    $media_stats_engine->logDownload( $rel_path );
    
    $data = fread( $media, 8192 );
    while( strlen( $data ) > 0 )
    {
        echo $data;
        $data = fread( $media, 8192 );
    }
    
?>
