<?php
    require_once( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "home/auth.php" );
    
    $op = array_key_exists( 'list_op', $_REQUEST )?$_REQUEST['list_op']:null;
    $listid = array_key_exists( 'listid', $_REQUEST )?$_REQUEST['listid']:null;
    
    if ( $op == "Delete" && isset( $listid ) )
    {
        require_once( "delete_list.php" );
        die();
    }
    else
    {
        require_once( "core/db/tables/SLUserTable.php" );
        require_once( "core/db/tables/SLPlayListTable.php" );
        require_once( "core/db/db_init.php" );
  

        $auth_user = $_SESSION[SL_AUTH_USER];
        $user_table = new SLUserTable( $db );
        $user = $user_table->getUserById( $auth_user->getUID() );
        $list_table = new SLPlayListTable( $db );
        $lists = $list_table->getPlayListsByUserID( $user->getUserID() );
  
        if ( $op == "Load" && isset( $listid ) )
        {
            require_once( "core/db/tables/SLPLEntryTable.php" );
            require_once( "core/playlist/PlayList.php" );
            require_once( "core/playlist/PlayListItem.php" );

            $entry_table = new SLPLEntryTable( $db );
            $entreis = $entry_table->getPLEntryForListIDByIndex( $listid );
            $list = new PlayList();
            foreach( $entreis as $entry )
            {
                $tag = $sl_media_info_cache->getMediaInfo( $entry->getMedia() );
                $item = new PlayListItem( $entry->getMedia(), $tag );
                $list->addItem( $item );
            }

            $_SESSION[SL_CUR_PLAYLIST] = $list;
            $sl_cur_playlist = $_SESSION[SL_CUR_PLAYLIST]; 
        }
        if ( $op == "New" )
        {
            $_SESSION[SL_CUR_PLAYLIST] = new PlayList();
            $sl_cur_playlist = $_SESSION[SL_CUR_PLAYLIST];
        }
        if ( $op == "Play" && isset( $listid ) )
        {
            require_once( "playlist.php" );
            die();
        }
    
        require_once( "core/theme/SLPageInfo.php" );
        $sl_page_info = &new SLPageInfo( SL_MY_ACCOUNT_PAGE, "My Account", "Streamline Playlists" );
        require_once( "core/theme/includes/account_header.php" );
        
?>
          <!-- Start home/playlists/index.php -->
          <table width="100%">
            <tr>
              <td valign="top" style="height: 100%">
                <h3>Current Playlist</h3>
                <table style="border: 1px solid black" width="100%" bgcolor="#FFFFFF" cellpadding="0" cellspacing="0">
                  <tbody>
                    <tr>
                      <td>
                        <table width="100%" cellspacing="0">
                          <tr bgcolor="#000066">
                            <td align="left" width="1%">
                              <font size="-1" face="Arial, Helvetica, sans-serif" color="white"><strong>#</strong></font>
                            </td>
                            <td align="left" width="98%" style="padding-left: 10px">
                              <font size="-1" face="Arial, Helvetica, sans-serif" color="white"><strong>Title</strong></font>
                            </td>
                            <td align="right" width="1%">
                              <font size="-1" face="Arial, Helvetica, sans-serif" color="white"><strong>Length</strong></font>
                            </td>
                          </tr>
                        </table>
                        <div style="overflow: scroll; height: 150px; width; 450px;">
                        
                          <table id="listTable" width="100%" cellspacing="0">
                            <tbody>
                            <?
                                if ( isset( $sl_cur_playlist ) && count( $sl_cur_playlist->getItems() ) > 0 )
                                {
                                    $i = 0;
                                    foreach( $sl_cur_playlist->getItems() as $item )
                                    {
                            ?>
                              <tr id="<?=$i+1?>">
                                <td width="1%" align="left">
                                  <font size="-1" face="Arial, Helvetica, sans-serif"><?=$i+1?></font>
                                </td>
                                <td width="98%" align="left" style="padding-left: 10px">
                                  <font size="-1" face="Arial, Helvetica, sans-serif"><?=$item->getTitle()?></font>
                                </td>
                                <td width="1%" align="right">
                                  <font size="-1" face="Arial, Helvetica, sans-serif"><?=$item->getLength()?></font>
                                </td>
                              </tr>
                            <?
                                        $i++;
                                    }
                                }
                                else
                                {
                            ?>
                              <tr>
                                <td width="1%" align="left"</td>
                                <td width="98%" align="left" style="padding-left: 10px"></td>
                                <td width="1%" align="right"></td>
                              </tr>
                            <?
                                }
                            ?>
                            </tbody>
                          </table>
                        </div>
                      </td>
                    </tr>
                  </tbody>
                </table>
                <form onsubmit="listTable.preprocessSubmit( this )" action="index.php" method="post">
                  <table width="100%">
                    <tr>
                      <td>
                        <input type="button" id="list_close" name="list_op" value="Edit" onClick="EditWindow=window.open('edit_list.php','EditPlayList','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=yes,width=450,height=336'); return false;">
                        <input type="button" id="list_save" name="list_op" value="Save" onClick="document.location='save_list.php'">
                      </td>
                      <td align="right">
                        <input type="button" id="list_play" name="list_op" value="Play" onClick="document.location='playlist.php'">
                      </td>
                    </tr>
                  </table>
                </form>
              </td>
              <td style="padding-left: 30px">
                <h3>Saved Playlists</h3>
                <form action="index.php" method="post">
                  <table>
                    <tr>
                      <td>
                        <select id="listid" name="listid" style="width: 100%" size="10">
                      <?
                          foreach( $lists as $list )
                          {
                              echo "<option value=".$list->getListID().">".$list->getTitle()."</option>\n";
                          }
                      ?>
                        </select>
                      </td>
                    </tr>
                    <tr>
                      <td align="center">
                        <input type="submit" id="list_load" name="list_op" value="Load">
                        <input type="submit" id="list_new" name="list_op" value="New">
                        <input type="submit" id="list_delete" name="list_op" value="Delete">
                        <input type="submit" id="list_play2" name="list_op" value="Play">
                      </td>
                    </tr>
                  </table>
                </form>
              </td>
            </tr>
          </table>
          <br>
          <a class="admin_link" href="../index.php">Back to My Account</a> 
          <!-- End home/playlists/index.php -->
<?
        require_once( "core/theme/includes/account_footer.php" );
    }
?>
