<?
    require_once( "../../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "home/auth.php" );
    require_once( "core/M3UGenerator.php" );
    require_once( "core/db/db_init.php" );
    
    $auth_user = $_SESSION[SL_AUTH_USER];

    if ( isset( $auth_user ) )
    {
        require( "core/db/tables/SLUserTable.php" );
        $sl_user_table = new SLUserTable( $db );
        $sl_user = $sl_user_table->getUserById( $auth_user->getUID() );
    } 
    
    $m3u_gen = new M3UGenerator( $sl_config, $sl_media_info_cache );
    
    
    if ( isset( $_REQUEST['listid'] ) )
    {
        $listid = $_REQUEST['listid'];

        require_once( "core/db/tables/SLPLEntryTable.php" );
        require_once( "core/db/tables/SLPlayListTable.php" );
        require_once( "core/playlist/PlayList.php" );
        require_once( "core/playlist/PlayListItem.php" );

        $list_table = new SLPlayListTable( $db );
        $list = $list_table->getPlayListById( $listid );
        $entry_table = new SLPLEntryTable( $db );
        $entreis = $entry_table->getPLEntryForListIDByIndex( $listid );
        $playlist = new PlayList(); 
        foreach( $entreis as $entry )
        {
            $tag = $sl_media_info_cache->getMediaInfo( $entry->getMedia() );
            $item = new PlayListItem( $entry->getMedia(), $tag );
            $playlist->addItem( $item );
        }

        $filename = $list->getTitle();
    }
    else
    {
        $playlist = $sl_cur_playlist;
        $filename = "current_playlist";
    }
    
    $m3u_file = $m3u_gen->generateM3UFromPlaylist( $playlist, $sl_user );

    
    header( "Content-Disposition: filename=\"$filename.m3u\"" );
    header( "Content-Length: ".strlen( $m3u_file ) );
    header( "Content-type: audio/x-mpegurl" );
    
    echo $m3u_file;
?>
