<?
    require_once( "../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "core/streamline_functions.php" );
    require_once( "core/theme/SLPageInfo.php" );


    // Since we use the .htaccess to direct all errors to this page,
    // we should reset the response to return code 200 in case it was
    // set to 404 for a file that doesn't exist.
    header('HTTP/1.1 200\r\n');
    
    
    if ( $sl_access_controler->requireLoginForBrowsing() )
    {
        require_once( "core/auth/php_login.php" );
    }

    if ( $sl_config->getMaskURLs() )
    {
        $info_root = $sl_config->getMediaServerRoot()."info/";
        $uri = stripslashes( $_SERVER['REQUEST_URI'] );
        $len = strlen( $uri );
        $rootlen = strlen( $info_root );
        $index = strpos( $uri, $info_root );
        $file_path = substr( $uri, $index + $rootlen , $len - ($index + $rootlen ) );
    }
    else
    {
        $file_path = stripslashes( urldecode( isset( $_REQUEST['media'] )?$_REQUEST['media']:"/" ) );
    }
        
    
    $file = urldecode( $file_path );

    $tag = $sl_media_info_cache->getMediaInfo( $file );
    
    $sl_page_info = &new SLPageInfo( SL_INFO_PAGE, $tag->getTitle() );
    require_once( "core/theme/includes/info_header.php" );
?>
    <!-- Start info/index.php -->
    <table class="info_table" cellspacing="0" cellpadding="0">
      <tr>
        <td class="info_media_panel">
          <table width="100%" cellspacing="0" cellpadding="0">
            <tr>
              <td class="info_media_label">Filename:</td><td class="info_media_value"><?=$tag->getFileName()?>&nbsp;</td>
            </tr>
            <tr>
              <td class="info_media_label">Title:</td><td class="info_media_value"><?=$tag->getTitle()?>&nbsp;</td>
            </tr>
            <tr>
              <td class="info_media_label">Artist:</td><td class="info_media_value"><?=$tag->getArtist()?>&nbsp;</td>
            </tr>
            <tr>
              <td class="info_media_label">Album:</td><td class="info_media_value"><?=$tag->getAlbum()?>&nbsp;</td>
            </tr>
            <tr>
              <td class="info_media_label">Track:</td><td class="info_media_value"><?=$tag->getTrack()?>&nbsp;</td>
            </tr>
            <tr>
              <td class="info_media_label">Year:</td><td class="info_media_value"><?=$tag->getYear()?>&nbsp;</td>
            </tr>
            <tr>
              <td class="info_media_label">Genre:</td><td class="info_media_value"><?=$tag->getGenre()?>&nbsp;</td>
            </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td class="info_stream_panel" valign="top" style="padding: 10px;">
          <fieldset>
            <legend align="left"><strong> Stream Info: </strong></legend>
            <table>
              <tr>
                <td class="info_stream_label">Length:</td><td class="info_stream_value"><?=$tag->getLength()?></td>
              </tr>
              <tr>
                <td class="info_stream_label">Bitrate:</td><td class="info_stream_value"><?=$tag->getBitrate()?>kbps</td>
              </tr>
              <tr>
                <td class="info_stream_label">Frequency:</td><td class="info_stream_value"><?=$tag->getSampleRate()?>Hz</td>
              </tr>
              <tr>
                <td class="info_stream_label">Mode:</td><td class="info_stream_value"><?=$tag->getChannels()?></td>
              </tr>
            </table>
          </fieldset>
        </td>
      </tr>
      <tr>
        <td class="info_button_panel" align="right" style="padding: 5px;">
          <input type="button" onClick="history.back()" value="Ok">
        </td>
      </tr>
    </table>
    <!-- End info/index.php -->
<?    
    require_once( "core/theme/includes/info_footer.php" );
?>
