<?php

    $db_type = $_SESSION["sl_install_db_type"];
    require_once( "core/db/connectors/$db_type/SLDataBase.php" );

    $db = new SLDataBase( $db_host, $db_user, $db_pass, $db_name );
    $connected = $db->connect();

    if ( !$connected )
    {
        $sl_install_errors[] = "Could not connect to the database to initialize the installtion.<br>".
            "Host: $db_host<br>User: $db_user<br>Pass: $db_pass<br>Name: $db_name";
        $sl_install_success = false;
    }
    else
    {
        //
        // Add the configuration to the config database
        //
        
        // Get the version and put it into the db.
        require_once( "core/sl_version.php" );
        $slv = "$sl_version_number-$sl_version_suffix";
        $db->query( "INSERT INTO config (name, value) VALUES ('SLVersion', '$slv')" );
        
        $wsr = $config->getWebServerRoot();
        $db->query( "INSERT INTO config (name, value) VALUES ('WebServerRoot', '$wsr')" );

        $msr = $config->getMediaServerRoot();
        $db->query( "INSERT INTO config (name, value) VALUES ('MediaServerRoot', '$msr')" );

        $mr = $config->getMediaRoot();
        $db->query( "INSERT INTO config (name, value) VALUES ('MediaRoot', '$mr')" );

        $title = $config->getServerTitle();
        $db->query( "INSERT INTO config (name, value) VALUES ('ServerTitle', '$title')" );

        $pbrowse = $config->getBrowsingRequiresAuth()?"yes":"no";
        $db->query( "INSERT INTO config (name, value) VALUES ('BrowsingRequiresAuth', '$pbrowse')" );
        
        $pstream = $config->getStreamingRequiresAuth()?"yes":"no";
        $db->query( "INSERT INTO config (name, value) VALUES ('StreamingRequiresAuth', '$pstream')" );
        
        $pdl = $config->getDownloadingRequiresAuth()?"yes":"no";
        $db->query( "INSERT INTO config (name, value) VALUES ('DownloadingRequiresAuth', '$pdl')" );
        
        $padmin = $config->getAdminRequiresAuth()?"yes":"no";
        $db->query( "INSERT INTO config (name, value) VALUES ('AdminRequiresAuth', '$padmin')" );
        
        $bFormat = implode( ",", $config->getBrowserColumns() );
        $db->query( "INSERT INTO config (name, value) VALUES ('BrowserColumns', '$bFormat')" );
        
        $sFormat = implode( "", $config->getStreamFormat() );
        $db->query( "INSERT INTO config (name, value) VALUES ('StreamFormat', '$sFormat')" );
        
        $order = implode( ",", $config->getSortOrder() );
        $db->query( "INSERT INTO config (name, value) VALUES ('SortOrder', '$order')" );
        
        $db->query( "INSERT INTO config (name, value) VALUES ('Theme', 'default')" );

        $db->query( "INSERT INTO config (name, value) VALUES ('GlobalHACEnabled', 'false')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('BrowseHACEnabled', 'false')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('StreamHACEnabled', 'false')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('DownloadHACEnabled', 'false')" );
        
        $db->query( "INSERT INTO config (name, value) VALUES ('GlobalHACDefault', 'allow')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('BrowseHACDefault', 'allow')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('StreamHACDefault', 'allow')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('DownloadHACDefault', 'allow')" );
        
        $db->query( "INSERT INTO config (name, value) VALUES ('BrowseAACEnabled', 'false')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('StreamAACEnabled', 'false')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('DownloadAACEnabled', 'false')" );
        
        $db->query( "INSERT INTO config (name, value) VALUES ('BrowseAACMode', '1')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('StreamAACMode', '1')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('DownloadAACMode', '1')" );
        
        $db->query( "INSERT INTO config (name, value) VALUES ('LogBrowsing', 'yes')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('LogStreaming', 'yes')" );
        $db->query( "INSERT INTO config (name, value) VALUES ('LogDownloading', 'yes')" );
        
        
        // Try to set the mask urls appropriately.
        $sapi = php_sapi_name();
        $sapi = strtolower( $sapi );
        $mask_urls = ($sapi == "apache" || $sapi == "apache2handler")?"yes":"no";

        $db->query( "INSERT INTO config (name, value) VALUES ('MaskURLs', '$mask_urls')" );

        
        // Add the default media types.
        $db->query( "INSERT INTO media_type ( extension, description, icon, enabled ) VALUES ( 'mp3', 'MPEG Layer III Audio', '', 1 )" );
        $db->query( "INSERT INTO media_type ( extension, description, icon, enabled ) VALUES ( 'ogg', 'OGG Vorbis Audio', '', 1 )" );

        
        //
        // Add the first user (which has admin rights) to the user table.
        //
        require_once( "core/db/tables/SLUserTable.php" );
        $table = new SLUserTable( $db );

        $admin_user = $_SESSION['SL_ADMIN_USER'];
        $admin_fname = $_SESSION['SL_ADMIN_FNAME'];
        $admin_lname = $_SESSION['SL_ADMIN_LNAME'];
        $admin_email = $_SESSION['SL_ADMIN_EMAIL'];
        $admin_pass = $_SESSION['SL_ADMIN_PASS'];
        
        $rand64= "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
        $random=rand();
        $salt=substr($rand64,$random  %  64,1).substr($rand64,($random/64) % 64,1);
        $salt=substr($salt,0,2); // Just in case
        $enc_pass = crypt( $admin_pass, $salt );
        
        // This user will by default have access to all of the services.
        $table->createUser( $admin_user, $admin_fname, $admin_lname, $enc_pass, $admin_email, true, true, true, true );

        $db->close();
    }
?>
