<?php

    require_once( "core/db/connectors/mysql/SLDataBase.php" );
    $db_admin_user = isset( $_REQUEST['sl_db_admin_user'] )?$_REQUEST['sl_db_admin_user']:null;
    $db_admin_pass = isset( $_REQUEST['sl_db_admin_pass'] )?$_REQUEST['sl_db_admin_pass']:null;
    
    if ( !isset( $db_admin_user ) || !isset( $db_admin_user ) )
    {
        header( "Location: db_admin_login.php" );
        echo "\n";
        die();
    }
    else
    {
        if ( $sl_install_success )
        {
            $db = new SLDataBase( $db_host, $db_admin_user, $db_admin_pass, $db_name );
            $created = $db->createDataBase();

            if ( !$created )
            {
                $sl_install_success = false;
                $sl_install_errors[] = $db->getError();
            }

            unset( $db );
        }

        
        // If we still are ok, try to install the tables.
        if ( $sl_install_success )
        {
            $db = new SLDataBase( $db_host, $db_admin_user, $db_admin_pass, $db_name );
            $connected = $db->connect();

            if ( !$connected  )
            {
                $error = $db->getError();
                $sl_install_success = false;
                $sl_install_errors[] = "Could not connect to the database to create the tables ($error).";
            }
            else
            {
                $sql_file = file( "init_db/sql/mysql.sql" );
                $tmp = implode( "", $sql_file );
                $sql_file = explode( ";", $tmp );

                $success = false;
                
                foreach( $sql_file as $line )
                {
                    $line = trim( $line );
                    
                    if ( $line == "" || $line[0] == "#" )
                    {
                        continue;
                    }

                    $success = $db->query( $line );

                    if ( !$success )
                    {
                        $sl_install_success = false;
                        $sl_install_errors[] = "Couldn't create table using SQL line: $line";
                        break;
                    }
                }
            }

            $db->close();
            unset( $db );
        }
       

        // If we still are ok, try to install the db user.
        if ( $sl_install_success )
        {
            $db = new SLDataBase( $db_host, $db_admin_user, $db_admin_pass, $db_name );
            $connected = $db->connect();

            if ( !$connected  )
            {
                $error = $db->getError();
                $sl_install_success = false;
                $sl_install_errors[] = "Could not connect to the database to create the user ($error).";
            }
            else
            {
                $sql = "GRANT SELECT, INSERT, UPDATE, DELETE ON $db_name.* TO $db_user@localhost IDENTIFIED BY '$db_pass'";
                $grant = $db->query( $sql );

                if ( !$grant )
                {
                    $sl_install_success = false;
                    $sl_install_errors[] ="Couldn't create user with the statement: $sql.  The SQL server said: ".$db->getError(); 
                }
            }
            
            $db->close();
        }

        if ( isset( $db ) )
        {
            unset( $db );
        }
    }
?>
