<?php
    require_once( "core/db/connectors/postgresql/SLDataBase.php" );
    $db_admin_user = isset( $_REQUEST['sl_db_admin_user'] )?$_REQUEST['sl_db_admin_user']:null;
    $db_admin_pass = isset( $_REQUEST['sl_db_admin_pass'] )?$_REQUEST['sl_db_admin_pass']:null;
    
    if ( !isset( $db_admin_user ) || !isset( $db_admin_user ) )
    {
        header( "Location: db_admin_login.php" );
        echo "\n";
        die();
    }
    else
    {
        if ( $sl_install_success )
        {
            $db = new SLDataBase( $db_host, $db_admin_user, $db_admin_pass, $db_name );
            $created = $db->createDataBase();
            
            if ( !$created )
            {
                $sl_install_success = false;
                $sl_install_errors[] = $db->getError();
            }

            unset( $db );
        }
        
        // If we still are ok, try to install the tables.
        if ( $sl_install_success )
        {
            $db = new SLDataBase( $db_host, $db_admin_user, $db_admin_pass, $db_name );
            $connected = $db->connect();

            if ( !$connected  )
            {
                $error = $db->getError();
                $sl_install_success = false;
                $sl_install_errors[] = "Could not connect to the database to create the tables ($error).";
            }
            else
            {
                $sql_file = file( "init_db/sql/postgresql.sql" );
                $tmp = implode( "", $sql_file );
                $sql_file = explode( ";", $tmp );

                $success = false;
                
                foreach( $sql_file as $line )
                {
                    $line = trim( $line );
                    
                    if ( $line == "" || $line[0] == "#" )
                    {
                        continue;
                    }

                    $success = $db->query( $line );

                    if ( !$success )
                    {
                        $sl_install_success = false;
                        $sl_install_errors[] = "Could create table using SQL line: $line";
                        break;
                    }
                }
            }

            $db->close();
            unset( $db );
        }

        // If we still are ok, try to install the db user.
        if ( $sl_install_success )
        {
            $db = new SLDataBase( $db_host, $db_admin_user, $db_admin_pass, $db_name );
            $connected = $db->connect();

            if ( !$connected  )
            {
                $error = $db->getError();
                $sl_install_success = false;
                $sl_install_errors[] = "Could not connect to the database to create the user ($error).";
            }
            else
            {
                $sql = "create user $db_user with password '$db_pass'";
                $create_user = $db->query( $sql );
                if ( !$create_user )
                {
                    echo "Couldn't create user with the statement: $sql.  The SQL server said: ".$db->getError();
                    die();
                }

                $grant = $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on config to $db_user;" );
                
                $grant = $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on media_type to $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on browselog to $db_user;" );
                $grant = $grant && $db->query( "GRANT UPDATE ON browselog_logid_seq TO $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on streamlog to $db_user;" );
                $grant = $grant && $db->query( "GRANT UPDATE ON streamlog_logid_seq TO $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on downloadlog to $db_user;" );
                $grant = $grant && $db->query( "GRANT UPDATE ON downloadlog_logid_seq TO $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on errorlog to $db_user;" );
                $grant = $grant && $db->query( "GRANT UPDATE ON errorlog_logid_seq TO $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on users to $db_user;" );
                $grant = $grant && $db->query( "GRANT UPDATE ON users_uid_seq TO $db_user;" );
                
                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on lastlogin to $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on media to $db_user;" );
                
                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on host_access to $db_user;" );
                $grant = $grant && $db->query( "GRANT UPDATE ON host_access_entryid_seq TO $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on agent_access to $db_user;" );
                $grant = $grant && $db->query( "GRANT UPDATE ON agent_access_entryid_seq TO $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on playlists to $db_user;" );
                $grant = $grant && $db->query( "GRANT UPDATE ON playlists_listid_seq TO $db_user;" );
                
                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on plentry to $db_user;" );
                $grant = $grant && $db->query( "GRANT UPDATE ON plentry_entryid_seq TO $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on stats_daily to $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on stats_media to $db_user;" );

                $grant = $grant && $db->query( "GRANT SELECT, INSERT, UPDATE, DELETE on stats_user to $db_user;" );


                if ( !$grant )
                {
                    $sl_install_success = false;
                    $sl_install_errors[] = "One ore more GRANT statements failed.  The last error from the server was: ".$db->getError(); 
                }
            }
            
            $db->close();
        }
        
        if ( isset( $db ) )
        {
            unset( $db );
        }
    }
?>
