<?php
    require_once( "../sl_root.php" );
    require_once( "core/php_extensions.php" );
    require_once( "check_pre_install.php" );

   
    $version = phpversion() > "4.3.0";
   
    $mysql = phpExtensionLoaded( "mysql" );
    $pgsql = phpExtensionLoaded( "pgsql" );
    $sqlite = phpExtensionLoaded( "sqlite" );
    
    $iconv = phpExtensionLoaded( "iconv" );
    
    $gd = phpExtensionLoaded( "gd" );
    
    $sapi = php_sapi_name();
    $sapi = strtolower( $sapi );
    
    $sapi_tested = 
        $sapi == "apache" || 
        $sapi == "apache2handler" ||
        $sapi == "isapi";

    // Windows Helper Apps
    require_once( "core/platform/platform_init.php" );
    $windows = $sl_platform->getName() == "Windows";
    $helper_apps = is_file( "../core/helperapps/tail.exe" );


    // dir perms
    $dir_perms = checkDirPerms();


    // Figure out if there are any errors or warnings.

    $errors = !( $mysql || $pgsql || $sqlite ) || 
              !$version ||
              !$iconv || 
              ( $windows && !$helper_apps ) ||
              !$dir_perms;

    $warnings = !$gd || !$sapi_tested;

    require_once( "installer.header.php" );

    $check_html = "<img src=\"images/check.gif\" alt=\"\Ok\">";
    $warning_html = "<img src=\"images/warning.gif\" alt=\"\Ok\">";
    $error_html = "<img src=\"images/error.gif\" alt=\"\Ok\">";
?>
          <h2 style="border-bottom: solid 1px black; padding-top: 20px">Streamline Installation Wizard: Requirements</h2>
          <p>
          Below is a list of requirements that must be met for Streamline to
          function correctly.  This installer will evaluate each requirement to
          see if your enviroment is suitable for Streamline.
          </p>
          <div style="padding: 20px;"> 
          <table width="100%" style="border: 1px solid black">
            <tr>
              <td bgcolor="#99CCFF"><strong>Requirement</strong></td>
              <td bgcolor="#99CCFF"><strong>Envirnoment</strong></td>
              <td bgcolor="#99CCFF"><strong>Result</strong></td>
            </tr>
            <tr>
              <td bgcolor="#CCCCCC">
                <table>
                  <tr>
                    <td class="req_title"><div class="req_title">PHP VERSION</div></td>
                  </tr>
                  <tr>
                    <td class="req_dsc">
                      Streamling requires a PHP Version Greater Than 4.3.0.
                    </td>
                  </tr>
                </table>
              </td>
              <td bgcolor="#EEEEEE">
                PHP Version: <?php echo phpversion(); ?>
              </td>
              <td bgcolor="#CCCCCC" align="center" valign="middle">
                <?php echo $version?$check_html:$error_html; ?>
              </td>
            </tr>
            <tr>
              <td bgcolor="#CCCCCC">
                <table>
                  <tr>
                    <td class="req_title"><div class="req_title">Database Extensions</div></td>
                  </tr>
                  <tr>
                    <td class="req_dsc">
                      Streamline requires at least on of the following PHP Extensions to connect
                      to a database to store it internal data:
                      <ul>
                        <li>MySQL (mysql)</li>
                        <li>PostgreSQL (pgsql)</li>
                        <li>SQLite (sqlite)</li>
                      </ul>
                    </td>
                  </tr>
                </table>
              </td>
              <td bgcolor="#EEEEEE">
<?
                if ( $mysql || $sqlite || $pgsql )
                {
?>
                The following extenstions were found:
                <ul>
<?
                  if ( $mysql )
                  {
?>
                    <li>MySQL</li>
<?
                  }
                  
                  if ( $pgsql )
                  {
?>
                    <li>PostgreSQL</li>
<?
                  }
                  if ( $sqlite )
                  {
?>
                    <li>SQLite</li>
<?
                  }
?>
                </ul>
<?
                }
                else
                {
?>
                No database extension were found.
<?
                }
?>
              </td>
              <td bgcolor="#CCCCCC" align="center" valign="middle">
                <?php echo $mysql || $sqlite || $pgsql?$check_html:$error_html; ?>
              </td>
            </tr>
            <tr>
              <td bgcolor="#CCCCCC">
                <table>
                  <tr>
                    <td class="req_title"><div class="req_title">PHP ICONV Support</div></td>
                  </tr>
                  <tr>
                    <td class="req_dsc">
                      Streamline requires the PHP ICONV extension to accurately read certain media meta information.
                    </td>
                  </tr>
                </table>
              </td>
              <td bgcolor="#EEEEEE">
<?
                if ( $iconv )
                {
?>
                The ICONV extension was detected.
<?
                }
                else
                {
?>
                It does not appear that ICONV extension is loaded.
<?
                }
?>
              </td>
              <td bgcolor="#CCCCCC" align="center" valign="middle">
                <?php echo $iconv?$check_html:$error_html; ?>
              </td>
            </tr>
            <tr>
              <td bgcolor="#CCCCCC">
                <table>
                  <tr>
                    <td class="req_title"><div class="req_title">PHP GD Support</div></td>
                  </tr>
                  <tr>
                    <td class="req_dsc">
                      Streamline requires the PHP GD extension to create statistics graphs.
                    </td>
                  </tr>
                </table>
              </td>
              <td bgcolor="#EEEEEE">
<?
                if ( $gd )
                {
?>
                The GD extension was detected.
<?
                }
                else
                {
?>
                It does not appear that GD extension is loaded.  Streamline will still function but statistics graphs will be unavailable.
<?
                }
?>
              <td bgcolor="#CCCCCC" align="center" valign="middle">
                <?php echo $gd?$check_html:$warning_html; ?>
              </td>
            </tr>
            <tr>
              <td bgcolor="#CCCCCC">
                <table>
                  <tr>
                    <td class="req_title"><div class="req_title">Server API</div></td>
                  </tr>
                  <tr>
                    <td class="req_dsc">
                      PHP can interface with a web server though several
                      different mechanisms.  These mechanisms may support
                      differing feature sets.  It is possible that Streamline
                      may work under some of these mechanisms but not others.
                      Streamline has been verified to work properly with the
                      following PHP-Server API's:
                      <ul>
                        <li>Apache</li>
                        <li>Apache2Handler</li>
                      </ul>
                    </td>
                  </tr>
                </table>
              </td>
              <td bgcolor="#EEEEEE">
<?
                if ( $sapi_tested )
                {
?>
                Your installation uses the <?php echo $sapi; ?> API which has been verified to work with Streamline. 
<?
                }
                else
                {
?>
                Your installation uses the <?php echo $sapi; ?> API which has not been verified to work with Streamline.  However this does not mean that streamline will not work, it just means the Streamline has not been tested in this environment.  If you encounter problems please contact the Stremaline Development Staff and ask for assistance.
<?
                }
?>
              <td bgcolor="#CCCCCC" align="center" valign="middle">
                <?php echo $sapi_tested?$check_html:$warning_html; ?>
              </td>
            </tr>
            <tr>
              <td bgcolor="#CCCCCC">
                <table>
                  <tr>
                    <td class="req_title"><div class="req_title">Directory Permissions</div></td>
                  </tr>
                  <tr>
                    <td class="req_dsc">
                      Streamline must create and write to several files to
                      complete the installation.  To do this the user that
                      streamlines php scripts will be executed as must have
                      write permissions to the following directories (
                      relative to the directory Streamline's php files are
                      installed in):
                      <ul>
                        <li>browse</li>
                        <li>stream</li>
                        <li>download</li>
                        <li>info</li>
                        <li>m3u</li>
                        <li>config</li>
                        <li>.</li>
                      </ul>
                    </td>
                  </tr>
                </table>
              </td>
              <td bgcolor="#EEEEEE">
<?
                if ( $dir_perms )
                {
?>
                    Streamline can write to all of the listed directories.
<?
                }
                else
                {
?>
                    Streamline can not write to one or more of the above directories.  Please check the directory permissions.
<?
                }
?>
              <td bgcolor="#CCCCCC" align="center" valign="middle">
                <?php echo $dir_perms?$check_html:$error_html; ?>
              </td>
            </tr>
<?
            if ( $windows )
            {
?>
            <tr>
              <td bgcolor="#CCCCCC">
                <table>
                  <tr>
                    <td class="req_title"><div class="req_title">Windows Helper Apps</div></td>
                  </tr>
                  <tr>
                    <td class="req_dsc">
                      Streamline needs to make use of several programs that are
                      generally installed on Unix/Linux based platforms, but
                      that are not installed on Windows by default.
                    </td>
                  </tr>
                </table>
              </td>
              <td bgcolor="#EEEEEE">
<?
                if ( $helper_apps )
                {
?>
                Your installation has the helper apps installed. 
<?
                }
                else
                {
?>
                Your installation does not have the helper apps installed.
                Please download them from the Streamine Web Site and install
                them according to the documenation provided.
<?
                }
?>
              <td bgcolor="#CCCCCC" align="center" valign="middle">
                <?php echo $helper_apps?$check_html:$error_html; ?>
              </td>
            </tr>
<?
            }
?>
          </table>
          <br>
          <table width="100%" style="border: 1px solid black; background: #DDDDDD;">
            <tr>
              <td style="padding: 10px;">
<?
        $on_click = "";
        $text = "";

        if ( $errors )
        {
            echo $error_html;
            
        }
        else if ( $warnings )
        {
            echo $warning_html;
        }
        else 
        {
            echo $check_html;
        }
?>
              </td>
              <td>
<?
        if ( $errors )
        {
            $on_click = "requirements.php";
            $text = "Re-Try";
?>
            This installer has determined that your environment does not meet
            the minimum requirements to install Streamline.  One or more errors
            are displayed in the table above.  Please rectify these errors
            before proceding.
<?
        }
        else 
        {
            $on_click = "installer.php";
            $text = "Next";
            
            if ( $warnings )
            {
?>
            This installer has detected several warnings that might cause
            Streamline to not perform as expected, however it is possbile that
            Streamline will still work.  You should review the warnings above,
            which may help explain any abberant behavior.
<?
            }
            else
            {
?>
            This installer has detected that your environment meets the
            requirements for installation.  Please proceed.
<?
            }
?>

<?
        }
?>
              </td>
            </tr>
            <tr>
              <td align="right" colspan="2">
                <button onClick="document.location='index.php'">Back</button>
                <button onClick="document.location='<?php echo $on_click; ?>'"><?php echo $text; ?></button>
              </td>
            </tr>
          </table>
          </div>
<?
    require_once( "installer.footer.php" );
?>
