<?php
    require_once( "../../sl_root.php" );
    require_once( "core/SLConfiguration.php" );
    session_start();

    $sl_db_type = $_SESSION['sl_db_type'];
    
    if ( $sl_db_type == "mysql" || $sl_db_type == "postgresql" )
    {
        if ( !isset( $_SESSION['sl_db_admin_user'] ) )
        {
           header( "Location: db_admin_login.php" );
           echo "\n";
           die();
        }
    }
    else if ( $sl_db_type == "sqlite" )
    {
        // SQLite is tricky.  If this upgrade is happening in place, then the
        // DB File is alread in the right spot.  If we aren't, then we need to
        // copy the old DB file to the correct new location.

        if ( isset( $_SESSION[SL_AUTO_UPGRADE] ) ) 
        {
            // Do I need to check anything here.
        }
        else
        {
            $sq_lite_db_file = isset( $_SESSION[SL_OLD_SQLITE_DB] )?$_SESSION[SL_OLD_SQLITE_DB]:"";

            if ( is_file( $sq_lite_db_file ) && is_readable( $sq_lite_db_file ) )
            {
                if ( !is_dir( "../../.sqlitedb" ) )
                {
                    mkdir( "../../.sqlitedb" );
                }
                // We found the file so lets copy it.
                copy( $sq_lite_db_file, "../../.sqlitedb/database" );
            }
            else
            {
                header( "Location: locate_previous_sqlite.php" );
            }
            // locate and copy old sqlite db.
        }
    }
    
    
    $installer_root = "../"; 
    require_once( "../installer.header.php" );

    $sl_upacks = &$_SESSION['sl_upacks'];
    $sl_version = $_SESSION['sl_version'];
    
    echo "<br>Begining upgrade process... <br><br>\n";
    
    for ( $i = 0; $i < count( $sl_upacks ); $i++ )
    {
        $from = $i == 0?$sl_version:$sl_upacks[$i - 1];
        $to = $sl_upacks[$i];
        echo "Upgrading: $from => $to<br>\n";
        require_once( "upgrade_packs/$to/apply_upgrade_pack.php" );
    }
    
    $_SESSION['sl_install_db_type'] = $_SESSION['sl_db_type'];
    $_SESSION['sl_install_db_host'] = $_SESSION['sl_db_host'];
    $_SESSION['sl_install_db_user'] = $_SESSION['sl_db_user'];
    $_SESSION['sl_install_db_pass'] = $_SESSION['sl_db_pass'];
    $_SESSION['sl_install_db_name'] = $_SESSION['sl_db_name']; 
    

    require_once( "installer/write_config_file.php" );
    
    $config_loaded = false;

    if ( is_readable( SL_ROOT."config/db.conf.php" ) )
    {
        require_once( "core/db/tables/SLConfigTable.php" );
        require_once( "core/SLConfigManager.php" );
        require_once( "core/db/db_init.php" );
       
        $config_table = new SLConfigTable( $db );
       
        $configManager = new SLConfigManager( $config_table );
        $config_loaded = $configManager->loadConfiguration();

        if ( $config_loaded )
        {
            $config = &$configManager->getConfiguration();
        
            $cur_msr = $config->getMediaServerRoot();
            $new_msr = $_SESSION['MediaServerRoot'];
            
            if( $cur_msr != $new_msr )
            {
                $msr_opt = $config_table->getOption( "MediaServerRoot" );
                $msr_opt->setValue( $new_msr );
                $config->setMediaServerRoot( $new_msr );
            }
            
            require_once( "installer/write_htaccess_files.php" );
        }
    }
?>
<br>
Upgrade complete.  <a href="../../browse/">Here</a>
<?php
        require_once( "../installer.footer.php" );
?>
