<?php
    require_once( "../../sl_root.php" );
    require_once( "installer/config_check.php" );
    require_once( "core/SLConfiguration.php" );
    
    session_start();
    
    if ( isset( $_REQUEST['sl_version'] ) )
    {
        $_SESSION['sl_version'] = $_REQUEST['sl_version'];
        header( "Location: confirm_upgrade.php" );
        echo( "\n" );
        die();
    }
    else
    {
        $sl_db_type = $_SESSION['sl_db_type'];
        $sl_db_host = $_SESSION['sl_db_host'];
        $sl_db_user = $_SESSION['sl_db_user'];
        $sl_db_pass = $_SESSION['sl_db_pass'];
        $sl_db_name = $_SESSION['sl_db_name'];

        require_once( "core/db/connectors/$sl_db_type/SLDataBase.php" );

        $db = new SLDataBase( $sl_db_host, $sl_db_user, $sl_db_pass, $sl_db_name );
        
        if ( $sl_db_type == "sqlite" )
        {
            $db->setDBPath( $_SESSION[SL_OLD_SQLITE_DB] );
        }
        
        $db->connect();
        
        require_once( "core/db/tables/SLConfigTable.php" );
        $table = &new SLConfigTable( $db );
        
        $version_opt = $table->getOption( "SLVersion" );
        $sl_version = isset( $version_opt )?$version_opt->getValue():"1.0-beta3";
        
        
        require_once( "sl_versions.php" );
        
        $installer_root = "../"; 
        require_once( "../installer.header.php" );
?>
      <h2 style="border-bottom: solid 1px black; padding-top: 20px">Streamline Installation Wizard: Upgrade</h2>
      <p>
        Streamline has attempted to detect the version of your current Database Schema and config files.  In most cases this should be correct, but if you are sure that the current version Database Schema is from a different version, you may adjust it to the appropriate value. 
      </p>
      <form action="verify_version.php">
        <table class="config_table">
          <tr>
            <td colspan="2">
              <hr>
            </td>
          </tr>
          <tr>
            <td class="value_title">Streamline Version: </td>
            <td>
              <select name="sl_version">
              <?php
                foreach( $sl_versions as $ver )
                {
                    echo "<option value=\"$ver\"".(($sl_version == $ver)?" selected='selected'":"").">".$ver."</option>\n";
                }
              ?>
              </select>
            </td>
          </tr>
          <tr>
            <td colspan="2" align="right">
              <hr>
              <input type="button" onClick="document.location='verify_config.php'" value="Back">
              <input type="submit" name="nav" value="Next">
            </td>
          </tr>
        </table>
      </form>
<?php
        require_once( "../installer.footer.php" );
    }
?>
