<?php
    require_once( "../sl_root.php" );
    require_once( "core/streamline_init.php" );
    require_once( "core/streamline_functions.php" );
    require_once( "core/M3UGenerator.php" );
    require_once( "core/db/db_init.php" );


    // Since we use the .htaccess to direct all errors to this page,
    // we should reset the response to return code 200 in case it was
    // set to 404 for a file that doesn't exist.
    header('HTTP/1.1 200\r\n');

    
    if ( $sl_access_controler->requireLoginForStreaming() )
    {
        require_once( "core/auth/http_login.php" );
    }   
    
    $sl_user = null;

    if ( isset( $_SESSION[SL_AUTH_USER] ) )
    {
        $auth_user = $_SESSION[SL_AUTH_USER];
        require( "core/db/tables/SLUserTable.php" );
        $sl_user_table = new SLUserTable( $db );
        $sl_user = $sl_user_table->getUserById( $auth_user->getUID() );
    }
    
    $m3u_root = joinURLPath( $sl_config->getMediaServerRoot(), "m3u" );
    
    
    if ( $sl_config->getMaskURLs() )
    {
        $uri = stripslashes( $_SERVER['REQUEST_URI'] );
        $urilen = strlen( $uri );
        
        $rootlen = strlen( $m3u_root );
        $index = strpos( $uri, $m3u_root );
        $loc = substr( $uri, $index + $rootlen , $urilen - ($index + $rootlen) );
    }
    else
    {
        $loc = stripslashes( urldecode( isset( $_REQUEST['media'] )?$_REQUEST['media']:"/" ) );
    }
    
    $pa = "play_all.m3u";
    $palen = strlen( $pa );

    $filelen = strlen( $loc );
    $filetail = substr( $loc, $filelen - $palen, $palen );
    if ( !strcmp( $filetail, $pa ) )
    {
        $loc = substr( $loc, 0 , $filelen  - $palen );
    }

    $loc = urldecode( $loc );
    
    $m3ugen = new M3UGenerator( $sl_config, $sl_media_info_cache );
    $m3u_file = $m3ugen->generateM3U( $loc, $sl_user );
    $temp = explode( "/", $loc );
    $filename = array_pop( $temp );
    if ( $filename == "" )
    {
        $filename = array_pop( $temp );
    }
    
    // Putting in the disposition attachment makes the browser ask you to open/save
    // every time.  This is wrong.
    // header( "Content-Disposition: attachment; filename=\"$filename.m3u\"" );
    header( "Content-Disposition: filename=\"$filename.m3u\"" );
    header( "Content-Length: ".strlen( $m3u_file ) );
    header( "Content-type: audio/x-mpegurl" );
    
    echo $m3u_file;
?>
